@-------------------------------------------------------------------------
@ Return of the Very Tiny Language for ARM
@ file : rvtl.s ver. 3.03
@ 2005/06/25
@ Copyright (C) 2003-2005 Jun Mizutani <mizutani.jun@nifty.ne.jp>
@ rvtl.s may be copied under the terms of the GNU General Public License.
@-------------------------------------------------------------------------


ARGMAX      =   15
VSTACKMAX   =   1024
MEMINIT     =   256*1024
LSTACKMAX   =   127
FNAMEMAX    =   256
LABELMAX    =   1024
VERSION     =   30300

VTL_LABEL   =   1
DETAILED_MSG=   1
FRAME_BUFFER=   1
@DEBUG       =   1

.ifdef FRAME_BUFFER
.include "fblib.s"
.endif

.ifdef DEBUG
.include "debug.s"
.endif

.include "vtllib.s"
.include "vtlsys.s"
.include "mt19937.s"


@==============================================================
        .text
        .global _start

_start:
                .align   2
@-------------------------------------------------------------------------
@ ƥν
@-------------------------------------------------------------------------
        @ ޥɥ饤ΰο򥹥å [argc] ¸
        ldr     r2, argc
        ldmfd   sp!, {r0}           @ r0 = argc
        str     r0, [r2]            @ argc ο¸
        str     sp, [r2, #+4]       @ argvp Ƭ¸

        @ ĶѿǼɥ쥹򥹥å[envp] ¸
        add     r0, sp, r0,LSL #2
        add     r0, r0, #4          @ Ķѿɥ쥹
        str     r0, [r2, #+8]       @ envp Ķѿΰ¸

        @ ޥɥ饤ΰ 2003/10/13
        ldr     r0, [r2]            @ argc
        ldr     r1, [r2, #+4]       @ argvp
        mov     r3, #1
        cmp     r0, r3
        beq     4f                  @ ʤʤ饹å
    1:  ldr     ip, [r1, r3,LSL #2] @ ip = argvp[r3]
        ldrb    ip, [ip]
        add     r3, r3, #1
        cmp     ip, #'-             @ -פ
        beq     2f                  @ -ȯ
        cmp     r3, r0
        bne     1b
        b       3f                  @ -פʤ
    2:
        str     r3, [r2]            @ argc ο򹹿
    3:  add     ip, r1, r3,LSL #2
        str     ip, [r2, #+16]      @ vtlѤΰʸؤƬ
        sub     r3, r0, r3
        str     r3, [r2, #+12]      @ vtlѤΰθĿ (argc_vtl0)

    4:  @ argv[0]="xxx/rvtlw" ʤ cgi⡼
        mov     v1, #0
        adr     r3, cginame         @ ʸ 'wltvr',0
        ldr     r0, [r1]            @ argv[0]
    5:  ldrb    ip, [r0], #1
        cmp     ip, #0
        bne     5b
        sub     r0, r0, #2          @ ʸκǽʸ(w)
    6:  ldrb    r1, [r0], #-1
        ldrb    ip, [r3], #+1
        cmp     ip, #0
        beq     7f                  @ found
        cmp     r1, ip
        bne     8f                  @ no
        b       6b
    7:  mov     v1, #1
    8:  ldr     r3, cgiflag
        str     v1, [r3]


        @ ߤü(termios) ¸ü륨OFF˺

        bl      GET_TERMIOS         @ termios ¸
        bl      SET_TERMIOS         @ üΥ륨OFF

        @ fpѿΰƬɥ쥹ꡢѿΥfpȤäƹԤ

        ldr     fp, VarArea         @ ̾Τν

        @ ƥѿνͤ

        ldr     r1, CodeArea
        mov     r0, #',             @ ץƬ
        str     r1, [fp, r0,LSL #2]
        mov     r0, #'=             @ ץƬ
        str     r1, [fp, r0,LSL #2]
        mvn     r3, #0              @ -1
        str     r3, [r1]            @ ޡ
        add     r1, r1, #4          @ ҡƬ
        mov     r0, #'&
        str     r1, [fp, r0,LSL #2]
        mov     r0, #0              @ 0 ϤƸͤ
        swi     #sys_brk            @ brk
        mov     r2, #'*             @ RAM
        str     r0, [fp, r2,LSL #2]

        ldr     r0, n672274774      @ 
        mov     r3, #'`             @ 
        str     r0, [fp, r3,LSL #2]
        bl      sgenrand

        @ ctrl-C, ctrl-ZѤΥʥϥɥϿ
        mov     r1, #0              @ ʥϥɥ
        ldr     r3, sig_action      @ r3=new_sig
        adr     r0, SigIntHandler
        str     r0, [r3]            @ nsa_sighandler
        str     r1, [r3, #+4]       @ nsa_mask
        mov     r0, #SA_NOCLDSTOP   @ ҥץߤ̵
        str     r0, [r3, #+8]       @ nsa_flags
        str     r1, [r3, #+12]      @ nsa_restorer

        mov     r0, #SIGINT         @ ^C
        mov     r1, r3              @ new_sig
        add     r2, r1, #16         @ old_sig
        swi     #sys_sigaction

        mov     r0, #SIG_IGN        @ ʥ̵
        str     r0, [r3]            @ nsa_sighandler
        mov     r0, #SIGTSTP        @ ^Z
        swi     #sys_sigaction

        @ PID¸(initμ)pid=1 ʤĶѿ
        swi     #sys_getpid
        str     r0, [fp, #-24]      @ pid ¸
        cmp     r0, #1
        bne     go

        ldr     r1, envp            @ pid=1 ʤĶѿ
        ldr     r0, env             @ envp Ķѿ
        str     r0, [r1]

        @ /etc/init.vtl¸ߤɤ߹
        adr     r0, initvtl         @ /etc/init.vtl
        bl      fropen              @ open
        ble     go                  @ ̵з³
        str     r0, [fp, #-8]       @ FileDesc
        bl      WarmInit2
        mov     r0, #1
        strb    r0, [fp, #-4]       @ Read from file
        strb    r0, [fp, #-2]       @ EOL=yes [fp, #-2]̤
        mov     v5, r0              @ EOLե饰
        b       Launch
    go:
        bl      WarmInit2
        mov     r0, #0
        ldr     r1, current_arg
        str     r0, [r1]            @ ѰȽ
        bl      LoadCode            @ Хץ
        bgt     Launch

.ifndef SMALL_VTL
        adr     r0, start_msg       @ ưå
        bl      OutAsciiZ
.endif

Launch:         @ λ
        ldr     r1, save_stack
        str     sp, [r1]            @ å¸

@-------------------------------------------------------------------------
@ ᥤ롼
@-------------------------------------------------------------------------
MainLoop:

        @ SIGINT(ctrl-Cβ)򸡽Ф֤᤹
        ldrb    ip, [fp, #-17]
        cmp     ip, #1              @ SIGINT ?
        bne     1f
        bl      WarmInit            @ ¹
        b       3f

        @ 0顼ȯåɽ
    1:  ldrb    ip, [fp, #-18]      @ 顼
        cmp     ip, #1
        bne     2f
        adr     r0, err_div0        @ 0å
        bl      OutAsciiZ
        bl      WarmInit            @ ¹

        @ ǥ顼򸡽Фåɽ
    2:  ldrb    ip, [fp, #-19]      @ ˥顼?
        cmp     ip, #0
        beq     3f
        b       Exp_Error           @ ǥ顼ȯ

        @ å (ľ EOL=1)
    3:
        cmp     v5, #0              @ EOL
        beq     4f

        @ Լ (󥽡ϤޤϥΥץ)
        ldrb    ip, [fp, #-3]
        cmp     ip, #1              @ ExecMode=Memory ?
        bne     ReadLine            @ Լ
        b       ReadMem             @ ꤫Լ

        @ ʤɤФ
    4:  bl      GetChar
    5:  cmp     v1, #' '            @ ɤФ
        bne     6f
        bl      GetChar
        b       5b

        @ ֹդʤԽ⡼
    6:
        bl      IsNum               @ ֹդʤԽ⡼
        bcs     7f
        bl      EditMode            @ Խ⡼
        b       MainLoop

        @ ʸʤѿۤʤХޥ
    7:  bl      IsAlpha
        bcs     Command             @ ޥɼ¹
    8:  bl      SetVar              @ ѿ
        b       MainLoop

LongJump:
        ldr     ip, save_stack
        ldr     sp, [ip]            @ å
        adr     r0, err_exp         @ ˶
        b       Error
Exp_Error:
        cmp     ip, #2
        adreq   r0, err_vstack      @ ѿåե
        adrne   r0, err_label       @ ٥̤å
        b       Error

@-------------------------------------------------------------------------
@ ʥϥɥ
@-------------------------------------------------------------------------
SigIntHandler:
        stmfd   sp!, {r0, lr}
        mov     r0, #1              @ SIGINT ʥ
        strb    r0, [fp, #-17]      @ fpϾƱ
        ldmfd   sp!, {r0, pc}

@-------------------------------------------------------------------------
@ ޥɥ饤ǻꤵ줿VTLɥե
@ ¹Ը塢bgt  ʤ
@-------------------------------------------------------------------------
LoadCode:
        stmfd   sp!, {r1, ip, lr}
        ldr     r3, current_arg     @ Ѥߤΰ
        ldr     r2, [r3]
        add     r2, r2, #1          @ ȥå
        ldr     ip, [r3, #4]        @ argc0 θĿ
        cmp     r2, ip
        beq     3f                  @ ٤ƽѤ
        str     r2, [r3]            @ Ѥߤΰ
        ldr     ip, [r3, #+8]       @ argvp Ƭ
        ldr     ip, [ip, r2,LSL #2] @ 
        ldr     r1, FileName
        mov     r2, #FNAMEMAX

    1:  ldrb    r0, [ip], #1
        strb    r0, [r1], #1
        tst     r0, r0
        beq     2f                  @ file open
        subs    r2, r2, #1
        bne     1b

    2:  ldr     r0, FileName        @ ե륪ץ
        bl      fropen              @ open
        ble     3f
        str     r0, [fp, #-8]       @ FileDesc
        mov     r0, #1
        strb    r0, [fp, #-4]       @ Read from file(0)
        mov     v5, #1              @ EOL=yes
    3:
        ldmfd   sp!, {r1, ip, pc}

@-------------------------------------------------------------------------
@ ʸ " ޤ EOL ޤ
@-------------------------------------------------------------------------
GetString:
        stmfd   sp!, {lr}
        mov     r2, #0
        ldr     r3, FileName
    1: @ next:
        bl      GetChar
        cmp     v1, #'"'
        beq     2f
        tst     v1, v1
        beq     2f
        strb    v1, [r3, r2]
        add     r2, r2, #1
        cmp     r2, #FNAMEMAX
        blo     1b
    2: @ exit:
        mov     v1, #0
        strb    v1, [r3, r2]
        ldmfd   sp!, {pc}

@-------------------------------------------------------------------------

n672274774:     .long   672274774
save_stack:     .long   save_stack0

current_arg:    .long   current_arg0
argc:           .long   argc0       @ [ 0]
argvp:          .long   argvp0      @ [ 4]
envp:           .long   envp0       @ [ 8]
argc_vtl:       .long   argc_vtl0   @ [12]
argp_vtl:       .long   argp_vtl0   @ [16]
exarg:          .long   exarg0
VarArea:        .long   VarArea0
CodeArea:       .long   CodeArea0
sig_action:     .long   new_sig
cgiflag:        .long   cgiflag0

.ifndef SMALL_VTL
                .align   2
start_msg:      .ascii   "RVTL v.3.03 2005/06/25, (C)2003-2005 Jun Mizutani\n"
                .ascii   "RVTL may be copied under the terms of the GNU "
                .asciz   "General Public License.\n"
                .align   2
.endif

initvtl:        .asciz   "/etc/init.vtl"
                .align   2
cginame:        .asciz   "wltvr"
                .align   2
err_div0:       .asciz   "\nDivided by 0!\n"
                .align   2
err_label:      .asciz   "\nLabel not found!\n"
                .align   2
err_vstack:     .asciz   "\nEmpty stack!\n"
                .align   2
err_exp:        .asciz   "\nError in Expression at line "
                .align   2

@-------------------------------------------------------------------------
@ r0 Υɥ쥹FileName˥ԡ
@-------------------------------------------------------------------------
  GetString2:
        stmfd   sp!, {lr}
        mov     r2, #0
        ldr     r3, FileName
    1:  ldrb    r1, [r0, r2]
        strb    r1, [r3, r2]
        tst     r1, r1
        beq     2f
        add     r2, r2, #1
        cmp     r2, #FNAMEMAX
        blo     1b
    2:  ldmfd   sp!, {pc}

@-------------------------------------------------------------------------
@ ե̾Хåե˼
@ ХåեƬɥ쥹 r0 ֤
@-------------------------------------------------------------------------
GetFileName:
        stmfd   sp!, {lr}
        bl      GetChar             @ skip =
        cmp     v1, #'='
        bne     2f                  @ 顼
        bl      GetChar             @ skip "
        cmp     v1, #'"'
        beq     1f
        b       2f                  @ 顼
    1: @ file
        bl      GetString
        ldr     r0, FileName        @ ե̾ɽ
        ldmfd   sp!, {pc}
    2: @ error
        add     sp, sp, #4          @ å
        b       pop_and_Error

FileName:       .long   FileName0

@-------------------------------------------------------------------------
@ ϤޤϥեϤ줿ɤ¹
@-------------------------------------------------------------------------
ReadLine:
        @ 1 : ϤȥեϤб
        ldrb    r0, [fp, #-4]       @ Read from console
        cmp     r0, #0
        beq     1f                  @ 󥽡뤫
        bl      READ_FILE           @ ե뤫
        b       MainLoop

    1:  @ ץץȤɽƥ󥽡뤫饭
        bl      DispPrompt
        ldr     r1, input
        mov     r0, #MAXLINE        @ 1 
        bl      READ_LINE           @ Խǽե
        mov     v3, r1              @ ϥХåեƬ
        mov     v2, v3
        mov     v5, #0              @ not EOL
        b       MainLoop

input:  .long   input0              @ vtllib.sbssΥХåե

@-------------------------------------------------------------------------
@ ˳Ǽ줿ɤμԤv3
@ v2 : Ƭɥ쥹
@-------------------------------------------------------------------------
ReadMem:
        ldr     r0, [v2]            @ JUMP褫⤷ʤ
        adds    r0, r0, #1          @ ԥեåȤ -1 ?
        beq     1f                  @ ʤ¹Խλ
        ldr     r0, [v2]
        add     v2, v2, r0          @ Next Line

        @ԤؤΥեåȤ0ʤХ
        ldr     r0, [v2]            @ ԥեå
        tst     r0, r0              @ 
        bpl     2f

        @ʤХ󥽡(쥯ȥ⡼)ꤷ
        @EOL1Ȥ뤳ȤǡԼ¥
    1:
        bl      CheckCGI            @ CGI⡼ɤʤ齪λ
        mov     r0, #0
        mov     v5, #1              @ EOL=yes
        strb    r0, [fp, #-3]       @ ExecMode=Direct
        b       MainLoop

        @ߤιֹ # ꤷơԤΥʬƬɥ쥹 v3 
    2:
        bl      SetLineNo           @ ֹ # 
        add     v3, v2, #+8         @ ԤΥƬ
        mov     v5, #0              @ EOL=no
        b       MainLoop

@-------------------------------------------------------------------------
@ ʸμ¹
@   ʸ¹Ԥ륵֥롼򥳡
@-------------------------------------------------------------------------
Command:
        @v1쥸ͤˤäƳƽ롼ƤӽФ
        subs    r1, v1, #'!
        blo     1f
        cmp     r1, #('/- '!)
        bhi     1f
        adr     r2, TblComm1            @ ץơ֥1 !-/
        ldr     r1, [r2, r1,LSL #2]     @ 襢ɥ쥹
        blx     r1                      @ б롼򥳡
        b       MainLoop
    1:  subs    r1, v1, #':'
        blo     2f
        cmp     r1, #('@ - ':)
        bhi     2f
        adr     r2, TblComm2            @ ץơ֥2 :-@
        ldr     r1, [r2, r1,LSL #2]     @ 襢ɥ쥹
        blx     r1                      @ б롼򥳡
        b       MainLoop
    2:  subs    r1, v1, #'['
        blo     3f
        cmp     r1, #('` - '[)
        bhi     3f
        adr     r2, TblComm3            @ ץơ֥3 [-`
        ldr     r1, [r2, r1,LSL #2]     @ 襢ɥ쥹
        blx     r1                      @ б롼򥳡
        b       MainLoop
    3:  subs    r1, v1, #'{'
        blo     4f
        cmp     r1, #('~ - '{)
        bhi     4f
        adr     r2, TblComm4            @ ץơ֥4 {-~
        ldr     r1, [r2, r1,LSL #2]     @ 襢ɥ쥹
        blx     r1                      @ б롼򥳡
        b       MainLoop
    4:  cmp     v1, #' '
        beq     MainLoop
        cmp     v1, #0
        beq     MainLoop
        cmp     v1, #8
        beq     MainLoop
        b       SyntaxError

@-------------------------------------------------------------------------
@ ޥѥץơ֥
@-------------------------------------------------------------------------
        .align   2
TblComm1:
        .long Com_GOSUB    @   21  !  GOSUB
        .long Com_String   @   22  "  ʸ
        .long Com_GO       @   23  #  GOTO ¹ιֹݻ
        .long Com_OutChar  @   24  $  ʸɽ
        .long Com_Error    @   25  %  ľνξ;ޤ usec ݻ
        .long Com_NEW      @   26  &  NEW, VTLɤκǽѥɥ쥹ݻ
        .long Com_Error    @   27  '  ʸ
        .long Com_FileWrite@   28  (  File 񤭽Ф
        .long Com_FileRead @   29  )  File ɤ߹, ɤ߹ߥݻ
        .long Com_BRK      @   2A  *  ǽ(brk), ݻ
        .long Com_VarPush  @   2B  +  ѿPUSH, û黻, 
        .long Com_Exec     @   2C  ,  fork & exec
        .long Com_VarPop   @   2D  -  ѿPOP, 黻, νʿ
        .long Com_Space    @   2E  .  
        .long Com_NewLine  @   2F  /  Խ, 黻
TblComm2:
        .long Com_Comment  @   3A  :  ޤ
        .long Com_IF       @   3B  @  IF
        .long Com_CdWrite  @   3C  <  rvtlɤΥե
        .long Com_Top      @   3D  =  Ƭɥ쥹
        .long Com_CdRead   @   3E  >  rvtlɤΥե
        .long Com_OutNum   @   3F  ?  ͽ  
        .long Com_DO       @   40  @  DO UNTIL NEXT
TblComm3:
        .long Com_RCheck   @   5B  [  Array index ϰϥå
        .long Com_Ext      @   5C  \  ĥ  黻(unsigned)
        .long Com_Return   @   5D  ]  RETURN
        .long Com_Comment  @   5E  ^  ٥, ¾OR黻, ٥뻲
        .long Com_USleep   @   5F  _  usleep, gettimeofday
        .long Com_RANDOM   @   60  `  ݻ ()
TblComm4:
        .long Com_FileTop  @   7B  {  եƬ(ҡΰ)
        .long Com_Function @   7C  |  Ȥ߹ߥޥ, 顼ݻ
        .long Com_FileEnd  @   7D  }  ե(ҡΰ)
        .long Com_Exit     @   7E  ~  VTLλ

@-------------------------------------------------------------------------
@ ɤ1ʸɤ߹
@ v3 μʸ v1 ɤ߹, v3 򼡤ΰ֤˹
@ 쥸¸
@-------------------------------------------------------------------------
GetChar:
        cmp     v5, #1              @ EOL=yes
        beq     2f
        ldrb    v1, [v3]
        tst     v1, v1
        moveq   v5, #1              @ EOL=yes
        add     v3, v3, #1
    2:
        mov     pc, lr              @ return

@-------------------------------------------------------------------------
@ ֹ򥷥ƥѿ # 
@-------------------------------------------------------------------------
SetLineNo:
        stmfd   sp!, {lr}
        ldr     r0, [v2, #+4]       @ Line No.
        mov     r3, #'#
        str     r0, [fp, r3,LSL #2] @ ֹ # 
        ldmfd   sp!, {pc}


@-------------------------------------------------------------------------
@ CGI ⡼ɤʤ rvtl λ
@-------------------------------------------------------------------------
CheckCGI:
        ldr     r3, cgiflag
        ldr     r3, [r3]
        cmp     r3, #1              @ CGI mode ?
        beq     Com_Exit
        mov     pc, lr              @ return

@-------------------------------------------------------------------------
@ ʸˡ顼
@-------------------------------------------------------------------------
SyntaxError:
        adr     r0, syntaxerr
Error:  bl      OutAsciiZ
        ldrb    r0, [fp, #-3]
        tst     r0, r0              @ ExecMode=Direct ?
        beq     3f
        ldr     r0, [v2, #+4]       @ 顼Թֹ
        bl      PrintLeft
        bl      NewLine
        add     r0, v2, #8          @ Ƭɥ쥹
    5:  bl      OutAsciiZ           @ 顼ɽ
        bl      NewLine
        sub     r3, v3, v2
        subs    r3, r3, #9
        beq     2f
        cmp     r3, #MAXLINE
        bhs     3f
        mov     r0, #' '            @ 顼
    1:  bl      OutChar
        subs    r3, r3, #1
        bne     1b
    2:  adr     r0, err_str
        bl      OutAsciiZ
        mov     r0, v1
        bl      PrintHex2           @ 顼ʸɽ
        mov     r0, #']'
        bl      OutChar
        bl      NewLine

    3:  bl      WarmInit            @ ƥ֤
        b       MainLoop

err_str:
        .asciz  "^  ["
        .align  2

@==============================================================

envstr:         .asciz   "PATH=/bin:/usr/bin"
                .align   2
env:            .long    envstr, 0

                .align   2
prompt1:        .asciz   "\n<"
                .align   2
prompt2:        .asciz   "> "
                .align   2
syntaxerr:      .asciz   "\nSyntax error! at line "
                .align   2
stkunder:       .asciz   "\nStack Underflow!\n"
                .align   2
stkover:        .asciz   "\nStack Overflow!\n"
                .align   2
vstkunder:      .asciz   "\nVariable Stack Underflow!\n"
                .align   2
vstkover:       .asciz   "\nVariable Stack Overflow!\n"
                .align   2
Range_msg:      .asciz   "\nOut of range!\n"
                .align   2

@-------------------------------------------------------------------------
@ ѿåϰϥ顼
@-------------------------------------------------------------------------
VarStackError_over:
        adr     r0, vstkover
        b       1f
VarStackError_under:
        adr     r0, vstkunder
    1:  bl      OutAsciiZ
        bl      WarmInit
        ldmfd   sp!, {pc}

@-------------------------------------------------------------------------
@ åإɥ쥹ץå (Ԥʸ֤)
@-------------------------------------------------------------------------
PushLine:
        stmfd   sp!, {r1-r2, lr}
        ldrb    r1, [fp, #-1]           @ LSTACK
        cmp     r1, #LSTACKMAX
        bge     StackError_over         @ overflow
        add     r2, fp, #512            @ (fp + 512) + LSTACK*4
        str     v2, [r2, r1,LSL #2]     @ push v2

        add     r1, r1, #1              @ LSTACK--
        ldrb    ip, [v3, #-1]
        cmp     ip, #0
        beq     1f                      @ 
        str     v3, [r2,r1,LSL #2]      @ push v3,(fp+512)+LSTACK*4
        b       2f
    1:
        sub     v3, v3, #1              @ 1ʸ᤹
        str     v3, [r2, r1,LSL #2]     @ push v3,(fp+512)+LSTACK*4
        add     v3, v3, #1              @ 1ʸʤ
    2:
        add     r1, r1, #1              @ LSTACK--
        strb    r1, [fp, #-1]           @ LSTACK
        ldmfd   sp!, {r1-r2, pc}

@-------------------------------------------------------------------------
@ å饢ɥ쥹ݥå (Ԥʸ֤)
@ v2, v3 
@-------------------------------------------------------------------------
PopLine:
        stmfd   sp!, {r1-r2, lr}
        ldrb    r1, [fp, #-1]           @ LSTACK
        cmp     r1, #2
        blo     StackError_under        @ underflow
        sub     r1, r1, #1              @ LSTACK--
        add     r2, fp, #512            @ (fp + 512) + LSTACK*4
        add     r2, r2, r1,LSL #2
        ldr     v3, [r2]                @ pop v3
        ldr     v2, [r2, #-4]           @ pop v2
        sub     r1, r1, #1
        strb    r1, [fp, #-1]           @ LSTACK
        ldmfd   sp!, {r1-r2, pc}

@-------------------------------------------------------------------------
@ å顼
@ r0 ѹ
@-------------------------------------------------------------------------
StackError_over:
        adr     r0, stkover
        b       1f
StackError_under:
        adr     r0, stkunder
        stmfd   sp!, {lr}
    1:  bl      OutAsciiZ
        bl      WarmInit
        ldmfd   sp!, {r1-r2, pc}

@-------------------------------------------------------------------------
@ åؽλ(r0)ץå
@-------------------------------------------------------------------------
PushValue:
        stmfd   sp!, {r1-r2, lr}
        ldrb    r1, [fp, #-1]           @ LSTACK
        cmp     r1, #LSTACKMAX
        bge     StackError_over
        add     r2, fp, #512            @ (fp + 512) + LSTACK*4
        str     r0, [r2, r1,LSL #2]     @ push r0
        add     r1, r1, #1              @ LSTACK++
        strb    r1, [fp, #-1]           @ LSTACK
        ldmfd   sp!, {r1-r2, pc}

@-------------------------------------------------------------------------
@ åνλ r0 
@-------------------------------------------------------------------------
PeekValue:
        stmfd   sp!, {r1-r2, lr}
        ldrb    r1, [fp, #-1]           @ LSTACK
        sub     r1, r1, #3              @ ,ʸ֤
        add     r2, fp, #512            @ (fp + 512) + LSTACK*4
        ldr     r0, [r2, r1,LSL #2]     @ read Value
        ldmfd   sp!, {r1-r2, pc}

@-------------------------------------------------------------------------
@ å齪λ(r0)ݥå
@-------------------------------------------------------------------------
PopValue:
        stmfd   sp!, {r1-r2, lr}
        ldrb    r1, [fp, #-1]           @ LSTACK
        cmp     r1, #1
        blo     StackError_under
        sub     r1, r1, #1              @ LSTACK--
        add     r2, fp, #512            @ (fp + 512) + LSTACK*4
        ldr     r0, [r2, r1,LSL #2]     @ pop r0
        strb    r1, [fp, #-1]           @ LSTACK
        ldmfd   sp!, {r1-r2, pc}

@-------------------------------------------------------------------------
@ ץץɽ
@-------------------------------------------------------------------------
DispPrompt:
        stmfd   sp!, {lr}
        bl      WinSize
        mov     r0, r0, LSR #16     @ 
        cmp     r0, #48
        blo     1f
        mov     r0, #7              @ long prompt
        bl      set_linetop         @ Ƭޡ
        adr     r0, prompt1         @ ץץɽ
        bl      OutAsciiZ
        ldr     r0, [fp, #-24]      @ pid μ
.ifdef DEBUG
        mov     r0, sp              @ sp β4
.endif
        bl      PrintHex4
        adr     r0, prompt2         @ ץץɽ
        bl      OutAsciiZ
        ldmfd   sp!, {pc}

    1:  mov     r0, #4              @ short prompt
        bl      set_linetop         @ Ƭޡ
        bl      NewLine
        ldr     r0, [fp, #-24]      @ pid μ
        bl      PrintHex2           @ pidβ1ɽ
        adr     r0, prompt2         @ ץץɽ
        bl      OutAsciiZ
        ldmfd   sp!, {pc}

@-------------------------------------------------------------------------
@ ϰϥ顼
@-------------------------------------------------------------------------
RangeError:
        stmfd   sp!, {lr}
        adr     r0, Range_msg       @ ϰϥ顼å
        bl      OutAsciiZ
        mov     r1, #'#             @ ֹ
        ldr     r0, [fp, r1,LSL #2]
        bl      PrintLeft
        bl      WarmInit
        ldmfd   sp!, {pc}

@-------------------------------------------------------------------------
@ ƥ
@-------------------------------------------------------------------------
    @ޥϸ򥳥󥽡

WarmInit:
        stmfd   sp!, {lr}
        bl      CheckCGI
        ldmfd   sp!, {lr}
WarmInit2:
        mov     r0, #0              @ 0
        strb    r0, [fp, #-4]       @ Read from console

    @ƥѿڤӺѥե饰ν
WarmInit1:
        mov     r0, #1              @ 1
        mov     r3, #'[             @ ϰϥåON
        str     r0, [fp, r3,LSL #2]
        mov     v5, #1              @ EOL=yes
        mov     r0, #0              @ 0
        ldr     r1, exarg           @ execve 
        str     r0, [r1]
        strb    r0, [fp, #-19]      @ Υ顼̵
        strb    r0, [fp, #-18]      @ ̵
        strb    r0, [fp, #-17]      @ SIGINTʥ̵
        strb    r0, [fp, #-3]       @ ExecMode=Direct
        strb    r0, [fp, #-1]       @ LSTACK
        str     r0, [fp, #-16]      @ VSTACK

        mov     pc, lr              @ return
@        ldmfd   sp!, {pc}

@-------------------------------------------------------------------------
@ GOSUB !
@-------------------------------------------------------------------------
Com_GOSUB:
        stmfd   sp!, {lr}
        ldrb    r0, [fp, #-3]
        tst     r0, r0              @ ExecMode=Direct ?
        bne     1f
        adr     r0, no_direct_mode
        bl      OutAsciiZ
        add     sp, sp, #4          @ å
        bl      WarmInit
        b       MainLoop
    1:
.ifdef VTL_LABEL
        bl      ClearLabel
.endif
        bl      SkipEqualExp        @ = ɤФ ɾ
        bl      PushLine
        bl      Com_GO_go
        ldmfd   sp!, {pc}

@-------------------------------------------------------------------------
@ Return ]
@-------------------------------------------------------------------------
Com_Return:
        stmfd   sp!, {lr}
        bl      PopLine             @ ߹Ԥθ̵
        mov     v5, #0              @ not EOL
        ldmfd   sp!, {pc}

@-------------------------------------------------------------------------
@ IF @  :
@-------------------------------------------------------------------------
Com_IF:
        stmfd   sp!, {lr}           @ lr ¸
        bl      SkipEqualExp        @ = ɤФ ɾ
        ldmfd   sp!, {lr}           @ lr 
        tst     r0, r0
        movne   pc, lr              @ ʤ롢ʤ鼡
Com_Comment:
        mov     v5, #1              @ EOL=yes ιԤ
        mov     pc, lr

@-------------------------------------------------------------------------
@ ̤ޥɽ(顼ȥå)
@-------------------------------------------------------------------------
pop2_and_Error:
        add     sp, sp, #4
pop_and_Error:
        add     sp, sp, #4
Com_Error:
        b       SyntaxError

@-------------------------------------------------------------------------
@ DO UNTIL NEXT @
@-------------------------------------------------------------------------
Com_DO:
        stmfd   sp!, {lr}
        ldr     r0, [fp, #-3]
        cmp     r0, #0              @ ExecMode=Direct ?
        bne     1f
        adr     r0, no_direct_mode
        bl      OutAsciiZ
        add     sp, sp, #4          @ å
        bl      WarmInit
        b       MainLoop
    1:
        bl      GetChar
        cmp     v1, #'='
        bne     7f                  @ DO ޥ
        ldrb    v1, [v3]            @ PeekChar
        cmp     v1, #'('            @ UNTIL?
        bne     2f                  @ ( Ǥʤ NEXT
        bl      SkipCharExp         @ (ɤФƼɾ
        mov     r2, r0              @ 
        bl      GetChar             @ ) ɤ(Ȥʤ)
        bl      PeekValue           @ λ
        cmp     r2, r0              @ r0:λ
        bne     6f                  @ continue
        b       5f                  @ 롼׽λ

    2: @ next (FOR)
        bl      IsAlpha             @ al=[A-Za-z] ?
        bcs     pop_and_Error       @ å SyntaxError
        add     r2, fp, v1,LSL #2   @ ѿΥɥ쥹
        bl      Exp                 @ Ǥդμ
        ldr     r3, [r2]            @ ͤ r3 
        str     r0, [r2]            @ ѿι
        mov     r2, r0              @ μͤr2
        bl      PeekValue           @ λ r0 
        ldrb    r1, [fp, #-20]
        cmp     r1, #1              @ ߽ ( > λ)
        bne     4f                  @ 

    3: @ ߽
        cmp     r3, r2              @  - 
        ble     pop_and_Error       @ Х顼
        cmp     r3, r0              @ r0:λ
        bgt     6f                  @ continue
        b       5f                  @ λ

    4: @ 
        cmp     r3, r2              @  - 
        bge     pop_and_Error       @ 礭Х顼
        cmp     r3, r0              @ r0:λ
        blt     6f                  @ continue

    5: @ exit 롼׽λ
        ldrb    r1, [fp, #-1]       @ LSTACK=LSTACK-3
        sub     r1, r1, #3
        strb    r1, [fp, #-1]       @ LSTACK
        ldmfd   sp!, {pc}

    6: @ continue UNTIL
        ldrb    r1, [fp, #-1]       @ LSTACK ꥢɥ쥹
        sub     r3, r1, #1
        add     r2, fp, r3,LSL #2
        add     r2, r2, #512
        ldr     v3, [r2]            @ fp+(r1-1)*4+512
        sub     r3, r3, #1
        add     r2, fp, r3,LSL #2
        add     r2, r2, #512
        ldr     v2, [r2]            @ fp+(r1-2)*4+512
        mov     v5, #0              @ not EOL
        ldmfd   sp!, {pc}

    7: @ do
        mov     r0, #1              @ DO
        bl      PushValue
        bl      PushLine
        ldmfd   sp!, {pc}

@-------------------------------------------------------------------------
@ ѿؤ, FORʸ
@ v1 ѿ̾ꤷƸƤӽФ
@-------------------------------------------------------------------------
SetVar:         @ ѿ
        stmfd   sp!, {lr}
        bl      SkipAlpha           @ ѿξĹʬɤФ
        add     v4, fp, r1,LSL #2   @ ѿΥɥ쥹
        cmp     v1, #'('
        beq     s_array1            @ 1Х
        cmp     v1, #'{'
        beq     s_array2            @ 2Х
        cmp     v1, #'['
        beq     s_array4            @ 4Х
        cmp     v1, #'*
        beq     s_strptr            @ ݥ󥿻
        cmp     v1, #'=
        bne     pop_and_Error

        @ ñѿ
    0:  bl      Exp                 @ ν(ɤ̵ǸƤ)
        str     r0, [v4]            @ 
        mov     r1, r0
        cmp     v1, #','            @ FORʸ?
        bne     3f                  @ λ

        ldrb    ip, [fp, #-3]       @ ExecMode=Direct ?
        cmp     ip, #0
        bne     1f                  @ ¹ԻʤOKʤΤFOR
        adr     r0, no_direct_mode  @ 顼ɽ
        bl      OutAsciiZ
        add     sp, sp, #4          @ å(pop)
        bl      WarmInit
        b       MainLoop            @ 

    1:  @ for
        mov     ip, #0
        strb    ip, [fp, #-20]      @ (0)
        bl      Exp                 @ λͤr0
        cmp     r0, r1              @ ͤȽλͤ
        bge     2f
        mov     ip, #1
        strb    ip, [fp, #-20]      @ ߽ ( >= λ)
    2:
        bl      PushValue           @ λͤ(NEXTȽ)
        bl      PushLine            @ Forʸľ
    3:
        ldmfd   sp!, {pc}

    s_array1:
        bl      s_array
        bcs     s_range_err         @ ϰϳ򥢥
        strb    r0, [v4, r1]        @ 
        ldmfd   sp!, {pc}

    s_array2:
        bl      s_array
        bcs     s_range_err         @ ϰϳ򥢥
        mov     r1, r1, LSL #1
        strh    r0, [v4, r1]        @ 
        ldmfd   sp!, {pc}

    s_array4:
        bl      s_array
        bcs     s_range_err         @ ϰϳ򥢥
        str     r0, [v4, r1,LSL #2] @ 
        ldmfd   sp!, {pc}

    s_strptr:                       @ ʸ򥳥ԡ
        bl      GetChar             @ skip =
        ldr     v4, [v4]            @ ѿˤϥԡ
        bl      RangeCheck          @ ԡϰϥå
        bcs     s_range_err         @ ϰϳ򥢥
        ldrb    v1, [v3]            @ PeekChar
        cmp     v1, #'"
        bne     s_sp0

        mov     r2, #0              @ ʸ˥ԡ
        bl      GetChar             @ skip "
    1:                              @ next char
        bl      GetChar
        cmp     v1, #'"
        beq     2f
        tst     v1, v1
        beq     2f
        strb    v1, [v4, r2]
        add     r2, r2, #1
        cmp     r2, #FNAMEMAX
        blo     1b
    2:                              @ done
        mov     v1, #0
        strb    v1, [v4, r2]
        mov     r1, #'%             @ %
        str     r2, [fp, r1,LSL #2] @ ԡ줿ʸ
        ldmfd   sp!, {pc}

    s_sp0:
        bl      Exp                 @ ԡΥɥ쥹
        cmp     v4, r0
        beq     3f
        mov     r2, v4              @ v4
        mov     v4, r0              @ RangeCheckv4򸫤
        bl      RangeCheck          @ ԡϰϥå
        mov     v4, r2              @ ԡ
        bcs     s_range_err         @ ϰϳ򥢥
        mov     r2, #0
    1:  ldrb    r1, [r0], #1
        strb    r1, [v4], #1
        add     r2, r2, #1
        cmp     r2, #0x40000        @ 262144ʸޤ
        beq     2f
        tst     r1, r1
        bne     1b
    2:  sub     r2, r2, #1          @ ʸ
        mov     r1, #'%             @ %
        str     r2, [fp, r1,LSL #2] @ ԡ줿ʸ
        ldmfd   sp!, {pc}

    3:  bl      StrLen
        mov     r2, #'%             @ %
        str     r1, [fp, r2,LSL #2] @ ʸ
        ldmfd   sp!, {pc}

    s_array:
        stmfd   sp!, {lr}
        bl      Exp                 @ 󥤥ǥå
        mov     r1, r0
        ldr     v4, [v4]
        bl      SkipCharExp         @ ν(ɤ̵ǸƤ)
        bl      RangeCheck          @ ϰϥå
        ldmfd   sp!, {pc}

    s_range_err:
        bl      RangeError          @ ǽϰϤĶ
        ldmfd   sp!, {pc}

no_direct_mode: .asciz   "\nDirect mode is not allowed!\n"
                .align   2

@-------------------------------------------------------------------------
@ ΥǽϰϤå
@ , < v4 < *
@-------------------------------------------------------------------------
RangeCheck:
        stmfd   sp!, {r0-r2, lr}
        mov     r2, #'[             @ ϰϥåե饰
        ldr     r0, [fp, r2,LSL #2]
        tst     r0, r0
        beq     2f                  @ 0 ʤåʤ
        ldr     r0, input_2         @ ץåȥХåեOK
        cmp     v4, r0
        beq     2f
        mov     r2, #','            @ ץƬ
        ldr     r0, [fp, r2,LSL #2]
        mov     r2, #'*'            @ RAM
        ldr     r1, [fp, r2,LSL #2]
        cmp     r0, v4              @ if = > addr, stc
        bhi     1f
        cmp     v4, r1              @ if * <= addr, stc
        bcc     2f
    1:  msr     cpsr_f, #0x20000000 @ set carry
        ldmfd   sp!, {r0-r2, pc}
    2:  msr     cpsr_f, #0x00000000 @ clear carry
        ldmfd   sp!, {r0-r2, pc}

input_2:         .long   input20

@-------------------------------------------------------------------------
@ ѿξĹʬɤФ
@   ѿ̾ r1 , ʸ v1 ֤
@   SetVar, Variable ǻ
@-------------------------------------------------------------------------
SkipAlpha:
        stmfd   sp!, {lr}
        mov     r1, v1            @ ѿ̾ r1 
    1:  bl      GetChar
        bl      IsAlpha
        bcc     1b
    2:  ldmfd   sp!, {pc}

@-------------------------------------------------------------------------
@ SkipEqualExp  = ³ɾ
@ SkipCharExp   1ʸɤФ ɾ
@ Exp           ɾ
@ r0 ֤ͤ (ɤ̵ǸƤӽФ, 1ʸɤߤ֤)
@-------------------------------------------------------------------------
SkipEqualExp:
        stmfd   sp!, {lr}
        bl      GetChar             @ check =
        ldmfd   sp!, {lr}

SkipEqualExp2:
        cmp     v1, #'='            @ ɤߤλ
        beq     Exp                 @ = ǧ
        adr     r0, equal_err       @
        bl      OutAsciiZ
        b       pop_and_Error       @ ʸˡ顼

SkipCharExp:
        stmfd   sp!, {lr}
        bl      GetChar             @ skip a character
        ldmfd   sp!, {lr}

Exp:
        stmfd   sp!, {r1, lr}
        ldrb    v1, [v3]            @ PeekChar
        cmp     v1, #' '
        bne     e_ok
        mov     r1, #1
        strb    r1, [fp, #-19]      @ ζϥ顼
        b       LongJump            @ 顼

    e_ok:
        stmfd   sp!, {r1-r3, ip}
        bl      Factor              @ r1 ˹
        mov     r0, r1              @ Τߤξ
    e_next:
        mov     r1, r0              @ ޤǤη̤r1˳Ǽ
        cmp     v1,  #'+'           @ ADD
        bne     e_sub
        mov     r3, r1              @ ͤ
        bl      Factor              @ 
        add     r0, r3, r1          @ 2û
        b       e_next
    e_sub:
        cmp     v1,  #'-'           @ SUB
        bne     e_mul
        mov     r3, r1              @ ͤ
        bl      Factor              @ 
        sub     r0, r3, r1          @ फ鱦򸺻
        b       e_next
    e_mul:
        cmp     v1,  #'*'           @ MUL
        bne     e_div
        mov     r3, r1              @ ͤ
        bl      Factor              @ 
        mul     r0, r3, r1          @ फ鱦򸺻
        b       e_next
    e_div:
        cmp     v1,  #'/'           @ DIV
        bne     e_udiv
        mov     r3, r1              @ ͤ
        tst     r3, r3
        mov     r2, #0              @ 
        rsbmi   r3, r3, #0          @ r3 = -r3
        movmi   r2, #1              @ 
        bl      Factor              @ 
        tst     r1, r1
        bne     e_div1
        mov     r2, #1
        strb    r2, [fp, #-18]      @ 顼
        b       e_exit
    e_div1:
        mov     ip, #0              @ 
        rsbmi   r1, r1, #0          @ r1 = -r1
        movmi   ip, #1              @ 
        mov     r0, r3
        bl      udiv                @ r0/r1 = r0...r1
        cmp     r2, #0
        rsbne   r1, r1, #0          @ r1 = -r1
        cmp     ip, r2              @
        rsbne   r0, r0, #0          @ r0 = -r0
        mov     r2, #'%'            @ ;¸
        str     r1, [fp, r2,LSL #2]
        mov     r1, r0              @  r1 
        b       e_next
    e_udiv:
        cmp     v1,  #'\\'           @ UDIV
        bne     e_and
        mov     r3, r1              @ ͤ
        bl      Factor              @ 
        tst     r1, r1
        bne     e_udiv1
        mov     r2, #1
        strb    r2, [fp, #-18]      @ 顼
        b       e_exit
    e_udiv1:
        mov     r0, r3
        bl      udiv                @ r0/r1 = r0...r1
        mov     r2, #'%'            @ ;¸
        str     r1, [fp, r2,LSL #2]
        mov     r1, r0              @  r1 
        b       e_next
    e_and:
        cmp     v1, #'&'            @ AND
        bne     e_or
        mov     r3, r1              @ ͤ
        bl      Factor              @ 
        and     r0, r3, r1
        b       e_next
    e_or:
        cmp     v1,  #'|'           @ OR
        bne     e_xor
        mov     r3, r1              @ ͤ
        bl      Factor              @ 
        orr     r0, r3, r1          @ ȱ OR
        b       e_next
    e_xor:
        cmp     v1, #'^'            @ XOR
        bne     e_equal
        mov     r3, r1              @ ͤ
        bl      Factor              @ 
        eor     r0, r3, r1          @ ȱ XOR
        b       e_next
    e_equal:
        cmp     v1, #'='            @ =
        bne     e_exp7
        mov     r3, r1              @ ͤ
        bl      Factor              @ 
        cmp     r1, r3              @ ȱ
        bne     e_false
    e_true:
        mov     r0, #1
        b       e_next
    e_false:
        mov     r0, #0              @ 0:
        b       e_next
    e_exp7:
        cmp     v1, #'<'            @ <
        bne     e_exp8
        ldrb    v1, [v3]            @ PeekChar
        cmp     v1, #'='            @ <=
        beq     e_exp71
        cmp     v1, #'>'            @ <>
        beq     e_exp72
        cmp     v1, #'<'            @ <<
        beq     e_shl
                                    @ <
        mov     r3, r1              @ ͤ
        bl      Factor              @ 
        cmp     r3, r1              @ ȱ
        bge     e_false
        b       e_true
    e_exp71:
        bl      GetChar             @ <=
        mov     r3, r1              @ ͤ
        bl      Factor              @ 
        cmp     r3, r1              @ ȱ
        bgt     e_false
        b       e_true
    e_exp72:
        bl      GetChar             @ <>
        mov     r3, r1              @ ͤ
        bl      Factor              @ 
        cmp     r3, r1              @ ȱ
        beq     e_false
        b       e_true
    e_shl:
        bl      GetChar             @ <<
        cmp     v1, #'<'            @
        bne     e_exp9
        mov     r3, r1              @ ͤ
        bl      Factor              @ 
        mov     r0, r3, LSL r1      @ 򱦹 SHL (*2)
        b       e_next
    e_exp8:
        cmp     v1, #'>'            @ >
        bne     e_exp9
        ldrb    v1, [v3]            @ PeekChar
        cmp     v1, #'='            @ >=
        beq     e_exp81
        cmp     v1,  #'>'           @ >>
        beq     e_shr
                                    @ >
        mov     r3, r1              @ ͤ
        bl      Factor              @ 
        cmp     r3, r1              @ ȱ
        ble     e_false
        b       e_true
    e_exp81:
        bl      GetChar             @ >=
        mov     r3, r1              @ ͤ
        bl      Factor              @ 
        cmp     r3, r1              @ ȱ
        blt     e_false
        b       e_true
    e_shr:
        bl      GetChar             @ >>
        mov     r3, r1              @ ͤ
        bl      Factor              @ 
        mov     r0, r3, LSR r1      @ 򱦹 SHR (/2)
        b       e_next
    e_exp9:
    e_exit:
        ldmfd   sp!, {r1-r3, ip}    @
        ldmfd   sp!, {r1, pc}       @ return

equal_err:
        .asciz   "\n= reqiured."
        .align   2

@-------------------------------------------------------------------------
@ UNIX֤ޥñ̤֤
@-------------------------------------------------------------------------
GetTime:
        stmfd   sp!, {r0, r2, r3, lr}
        ldr     r3, TV0
        mov     r0, r3
        add     r1, r3, #8          @ TZ
        swi     #sys_gettimeofday
        ldr     r1, [r3]            @ sec
        ldr     r0, [r3, #4]        @ usec
        mov     r2, #'%'            @ ; usec ¸
        str     r0, [fp, r2,LSL #2]
        bl      GetChar
        ldmfd   sp!, {r0, r2, r3, pc}

TV0:    .long   TV

@-------------------------------------------------------------------------
@ ޥñ̤Υ꡼ _=n
@-------------------------------------------------------------------------
Com_USleep:
        stmfd   sp!, {v1, lr}
        bl      SkipEqualExp        @ = ɤФ ɾ
        mov     r1, #0
        ldr     v1, TV0             @ 5
        str     r1, [v1]            @ sec  0
        str     r0, [v1, #+4]       @ usec
        mov     r0, r1
        mov     r2, r1
        mov     r3, r1
        swi     #sys_select
        bl      CheckError
        ldmfd   sp!, {v1, pc}

@-------------------------------------------------------------------------
@ ѿλ, r1 ֤ͤ
@ ѿȤv4(¸)
@ r0 Ͼ̤Factor¸
@-------------------------------------------------------------------------
Variable:
        stmfd   sp!, {v4, lr}
        bl      SkipAlpha           @ ѿ̾ r1
        add     v4, fp, r1,LSL #2   @ ѿΥɥ쥹
        cmp     v1, #'('
        beq     v_array1            @ 1Х
        cmp     v1, #'{'
        beq     v_array2            @ 2Х
        cmp     v1, #'['
        beq     v_array4            @ 4Х
        ldr     r1, [v4]            @ ñѿ
        ldmfd   sp!, {v4, pc}       @ return

    v_array1:
        bl      Exp                 @ 1Х
        ldr     v4, [v4]
        bl      RangeCheck          @ ϰϥå
        bcs     v_range_err         @ ϰϳ򥢥
        ldrb    r1, [v4, r0]
        bl      GetChar             @ skip )
        ldmfd   sp!, {v4, pc}       @ return

    v_array2:
        bl      Exp                 @ 2Х
        ldr     v4, [v4]
        bl      RangeCheck          @ ϰϥå
        bcs     v_range_err         @ ϰϳ򥢥
        mov     r0, r0, LSL #1
        ldrh    r1, [v4, r0]
        bl      GetChar             @ skip }
        ldmfd   sp!, {v4, pc}       @ return

    v_array4:
        bl      Exp                 @ 4Х
        ldr     v4, [v4]
        bl      RangeCheck          @ ϰϥå
        bcs     v_range_err         @ ϰϳ򥢥
        ldr     r1, [v4, r0,LSL #2]
        bl      GetChar             @ skip ]
        ldmfd   sp!, {v4, pc}       @ return

    v_range_err:
        bl      RangeError
        ldmfd   sp!, {v4, pc}       @ return

@-------------------------------------------------------------------------
@ ѿ
@ r1 ֤ͤ (ɤ̵ǸƤӽФ, 1ʸɤߤ֤)
@-------------------------------------------------------------------------
Factor:
        stmfd   sp!, {r0, r2, lr}   @
        bl      GetChar
        bl      IsNum
        bcs     f_bracket
        bl      Decimal             @ 10
        mov     r1, r0
        ldmfd   sp!, {r0, r2, pc}   @

    f_bracket:
        cmp     v1, #'('
        bne     f_yen
        bl      Exp                 @ å
        mov     r1, r0              @ ͤ r1
        bl      GetChar             @ skip )
        ldmfd   sp!, {r0, r2, pc}   @

    f_yen:
        cmp     v1, #'\\            @ '\'
        bne     f_rand
        ldrb    v1, [v3]            @ PeekChar
        cmp     v1, #'\\            @ '\\'
        beq     f_env

        bl      Exp                 @ ֹ򼨤
        ldr     r2, argc_vtl        @ vtlѤΰθĿ
        ldr     r2, [r2]
        cmp     r0, r2              @ ֹȰο
        blt     2f                  @ ֹ < ο
        ldr     r2, argvp           @ not found
        ldr     r2, [r2]            @ argvp0
        ldr     r1, [r2]            @ argvp[0]
    1:  ldrb    r2, [r1], #1        @ 0õ
        cmp     r2, #0
        bne     1b
        sub     r1, r1, #1          @ argv[0]EOL
        b       3f
    2:  ldr     r2, argp_vtl        @ found
        ldr     r2, [r2]
        ldr     r1, [r2, r0,LSL #2] @ ʸƬɥ쥹
    3:  ldmfd   sp!, {r0, r2, pc}   @

    f_env:
        bl      GetChar             @ skip '\'
        bl      Exp
        ldr     r2, envp
        ldr     r2, [r2]            @ envp0
        mov     r1, #0
    4:  ldr     ip, [r2, r1, LSL #2]
        cmp     ip, #0
        beq     5f
        add     r1, r1, #1
        b       4b
    5:
        cmp     r0, r1
        bge     6f                  @ ֹ椬
        ldr     r1, [r2, r0,LSL #2] @ ʸƬɥ쥹
        ldmfd   sp!, {r0, r2, pc}   @ return
    6:
        add     r1, r2, r1,LSL #2   @ 0ؤΥݥ(ʸ)
        ldmfd   sp!, {r0, r2, pc}   @ return


    f_rand:
        cmp     v1, #'`'
        bne     f_hex
        bl      genrand             @ ɤ߽Ф
        mov     r1, r0
        bl      GetChar
        ldmfd   sp!, {r0, r2, pc}   @

    f_hex:
        cmp     v1, #'$'
        bne     f_time
        bl      Hex                 @ 16ʿޤ1ʸ
        ldmfd   sp!, {r0, r2, pc}   @

    f_time:
        cmp     v1, #'_'
        bne     f_num
        bl      GetTime             @ ֤֤
        ldmfd   sp!, {r0, r2, pc}   @

    f_num:
        cmp     v1, #'?'
        bne     f_char
        bl      NumInput            @ 
        ldmfd   sp!, {r0, r2, pc}   @

    f_char:
        cmp     v1, #0x27
        bne     f_neg
        bl      CharConst           @ ʸ
        ldmfd   sp!, {r0, r2, pc}   @

    f_neg:
        cmp     v1, #'-'
        bne     f_abs
        bl      Factor              @ 
        mov     r2, #0
        sub     r1, r2, r1
        ldmfd   sp!, {r0, r2, pc}   @

    f_abs:
        cmp     v1, #'+'
        bne     f_realkey
        bl      Factor              @ ѿ
        tst     r1, r1
        bpl     f_exit
        mov     r2, #0
        sub     r1, r2, r1
        ldmfd   sp!, {r0, r2, pc}   @

    f_realkey:
        cmp     v1, #'@'
        bne     f_winsize
        bl      RealKey             @ ꥢ륿७
        mov     r1, r0
        bl      GetChar
        ldmfd   sp!, {r0, r2, pc}   @

    f_winsize:
        cmp     v1, #'.'
        bne     f_pop
        bl      WinSize             @ ɥ
        mov     r1, r0
        bl      GetChar
        ldmfd   sp!, {r0, r2, pc}   @

    f_pop:
        cmp     v1, #';'
        bne     f_label
        ldr     r2, [fp, #-16]      @ VSTACK
        subs    r2, r2, #1
        movlo   r2, #2
        strlob  r2, [fp, #-19]      @ ѿå顼
        blo     1f
        add     r0, fp, r2,LSL #2
        add     r0, r0, #1024       @ fp+r2*4+1024
        ldr     r1, [r0]            @ ѿå
        str     r2, [fp, #-16]      @ åݥ󥿹
    1:  bl      GetChar
        ldmfd   sp!, {r0, r2, pc}   @

    f_label:
.ifdef VTL_LABEL
        cmp     v1, #'^'
        bne     f_var
        bl      LabelSearch         @ ٥Υɥ쥹
        movcs   r2, #3
        strcsb  r2, [fp, #-19]      @ ٥륨顼
    2:  ldmfd   sp!, {r0, r2, pc}   @
.endif

    f_var:
        bl      Variable            @ ѿ󻲾
    f_exit:
        ldmfd   sp!, {r0, r2, pc}   @

@-------------------------------------------------------------------------
@ 󥽡뤫
@-------------------------------------------------------------------------
NumInput:
        stmfd   sp!, {r0, r2, lr}   @
        mov     r2, v5              @ EOL
        mov     r0, #MAXLINE        @ 1 
        stmfd   sp!, {v3}
        ldr     r1, input2          @ ԥꥢ
        bl      READ_LINE3
        mov     v3, r1
        ldrb    v1, [v3], #1        @ 1ʸɤ
        bl      Decimal
        ldmfd   sp!, {v3}
        mov     r1, r0
        mov     v5, r2              @ EOL
        bl      GetChar
        ldmfd   sp!, {r0, r2, pc}   @

@-------------------------------------------------------------------------
@ 󥽡뤫 input2 ʸ
@-------------------------------------------------------------------------
StringInput:
        stmfd   sp!, {r0, r2-r3, lr}    @
        mov     r2, v5              @ EOL
        mov     r0, #MAXLINE        @ 1 
        ldr     r1, input2          @ ԥꥢ
        bl      READ_LINE3
    2:  mov     r3, #'%             @ %
        str     r0, [fp, r3,LSL #2] @ ʸ֤
        mov     v5, r2              @ EOL
        bl      GetChar
        ldmfd   sp!, {r0, r2-r3, pc}    @

@-------------------------------------------------------------------------
@ ʸͤѴ
@ r1 ˿֤ͤ
@-------------------------------------------------------------------------
CharConst:
        stmfd   sp!, {r0, r2, lr}   @
        mov     r1, #0
        mov     r0, #4              @ ʸ4ХȤޤ
    1:
        bl      GetChar
        cmp     v1, #0x27            @ #'''
        beq     2f
        add     r1, v1, r1, LSL #8
        subs    r0, r0, #1
        bne     1b
    2:
        bl      GetChar
        ldmfd   sp!, {r0, r2, pc}   @

@-------------------------------------------------------------------------
@ 16ʸͤѴ
@ r1 ˿֤ͤ
@-------------------------------------------------------------------------
Hex:
        ldrb    v1, [v3]            @ check $$
        cmp     v1, #'$
        beq     StringInput
        stmfd   sp!, {r0, r2, lr}   @
        mov     r1, #0
        mov     r2, r1
    1:
        bl      GetChar             @ $ μʸ
        bl      IsNum
        bcs     2f
        sub     v1, v1, #'0'        @ Ѵ
        b       4f
    2:
        cmp     v1, #' '            @ ʳ
        beq     5f
        cmp     v1, #'A'
        blo     5f                  @ 'A' 꾮ʤ
        cmp     v1, #'F'
        bhi     3f
        sub     v1, v1, #55         @ -'A'+10 = -55
        b       4f
    3:
        cmp     v1, #'a'
        blo     5f
        cmp     v1, #'f'
        bhi     5f
        sub     v1, v1, #87         @ -'a'+10 = -87
    4:
        add     r1, v1, r1, LSL #4
        add     r2, r2, #1
        b       1b
    5:
        tst     r2, r2
        beq     CharInput
        ldmfd   sp!, {r0, r2, pc}   @

@-------------------------------------------------------------------------
@ 󥽡뤫 1 ʸ, EBX֤
@-------------------------------------------------------------------------
CharInput:
        bl      InChar
        mov     r1, r0
        ldmfd   sp!, {r0, r2, pc}   @

@-------------------------------------------------------------------------
@ ԤԽ
@   r0 ֹ
@ r4  v1    ʸ(GetChar֤)
@ r5  v2    ¹ԻƬ
@ r6  v3    ؤΥݥ(getcharǹ)
@ r7  v4    ѿΥɥ쥹
@ r8  v5    EOLե饰
@ r9  v6    ѿåݥ
@ r10 v7    ϹԥХåե
@ r11 v8 fp ѿΰƬɥ쥹
@ r12 ip    ɽŪʺȥ쥸
@-------------------------------------------------------------------------
LineEdit:
        bl      LineSearch          @ ϺѤ߹ֹõ
        bcc     4f                  @ ĤʤΤǽλ
        ldr     v3, input           @ ϥХåե
        ldr     r0, [v2, #+4]
        bl      PutDecimal          @ ֹ񤭹
        mov     r0, #' '
        strb    r0, [v3]
        add     v3, v3, #1
        add     v2, v2, #8
    2:
        ldrb    r0, [v2], #1        @ ԤϥХåե˥ԡ
        strb    r0, [v3], #1
        cmp     r0, #0
        bne     2b                  @ ?
    3:
        bl      DispPrompt
        mov     r0, #MAXLINE        @ 1 
        ldr     r1, input
        bl      READ_LINE2          @ ѹ
        mov     v3, r1
    4:
        mov     v5, #0              @ EOL=no, ϺѤ
        ldmfd   sp!, {pc}           @ Mainloopreturn

@-------------------------------------------------------------------------
@ ListMore
@   eax ɽϹֹ
@-------------------------------------------------------------------------
ListMore:
        bl      LineSearch          @ ɽϹԤ򸡺
        bl      GetChar             @ skip '+'
        bl      Decimal             @ ɽԿ
        movcs   r0, #20             @ ɽԿ̵20
        mov     r2, v2
    1:  ldr     r1, [r2]            @ ԤޤǤΥեå
        tst     r1, r1
        bmi     List_all            @ ɺǽ?
        ldr     r3, [r2, #+4]       @ ֹ
        add     r2, r2, r1          @ Ƭ
        subs    r0, r0, #1
        bne     1b
        b       List_loop

@-------------------------------------------------------------------------
@ List
@  r0 ɽϹֹ
@  v2 ɽƬɥ쥹(˲)
@-------------------------------------------------------------------------
List:
        tst     r0, r0
        bne     1f                  @ partial
        mov     r1, #'=             @ ץƬ
        ldr     v2, [fp, r1,LSL #2]
        b       List_all

    1:  bl      LineSearch          @ ɽϹԤ򸡺
        bl      GetChar             @ ͤǤ -
        bl      Decimal             @ ϰϺǽ
        movcc   r3, r0              @ λֹ
        bcc     List_loop

List_all:
        mvn     r3, #0              @ ǽޤɽ()
List_loop:
        ldr     r2, [v2]            @ ԤޤǤΥեå
        tst     r2, r2
        bmi     6f                  @ ɺǽ?
@        ble     6f                  @ ɺǽ?
        ldr     r0, [v2, #+4]       @ ֹ
        cmp     r3, r0
        blo     6f
        bl      PrintLeft           @ ֹɽ
        mov     r0, #' '
        bl      OutChar
        mov     r1, #8
    4:
        ldrb    r0, [v2, r1]        @ ʬɽ
        cmp     r0, #0
        beq     5f                  @ 
        bl      OutChar
        add     r1, r1, #1          @ 1ʸ
        b       4b
    5:  bl      NewLine
        add     v2, v2, r2
        b       List_loop           @ Խ

    6:
        mov     v5, #1              @ ˹ EOL=yes
        ldmfd   sp!, {pc}           @ Mainloopreturn

.ifdef DEBUG

@-------------------------------------------------------------------------
@ ǥХåѥץԥꥹ <xxxx> 1#
@-------------------------------------------------------------------------
DebugList:
        stmfd   sp!, {r0-r3, v2, lr}
        mov     r1, #'=             @ ץƬ
        ldr     v2, [fp, r1,LSL #2]
        mov     r0, v2
        bl      PrintHex8           @ ץƬɽ
        mov     r0, #' '
        bl      OutChar
        mov     r1, #'&             @ ҡƬ
        ldr     r0, [fp, r1,LSL #2]
        bl      PrintHex8           @ ҡƬɽ
        sub     r2, r0, v2          @ ץΰ襵
        mov     r0, #' '
        bl      OutChar
        mov     r0, r2
        bl      PrintLeft
        bl      NewLine
        mvn     r3, #0              @ ǽޤɽ()
    1:
        mov     r0, v2
        bl      PrintHex8           @ Ƭɥ쥹
        ldr     r2, [v2]            @ ԤޤǤΥեå
        mov     r0, #' '
        bl      OutChar
        mov     r0, r2
        bl      PrintHex8           @ եåȤ16ɽ
        mov     r1, #4              @ 4屦
        bl      PrintRight          @ եåȤ10ɽ
        mov     r0, #' '
        bl      OutChar
        tst     r2, r2
        ble     4f                  @ ɺǽ?

        ldr     r0, [v2, #+4]       @ ֹ
        cmp     r3, r0
        blo     4f
        bl      PrintLeft           @ ֹɽ
        mov     r0, #' '
        bl      OutChar
        mov     r1, #8
    2:
        ldrb    r0, [v2, r1]        @ ʬɽ
        cmp     r0, #0
        beq     3f                  @ 
        bl      OutChar
        add     r1, r1, #1          @ 1ʸ
        b       2b
    3:  bl      NewLine
        add     v2, v2, r2
        b       1b                  @ Խ

    4:  bl      NewLine
        ldmfd   sp!, {r0-r3, v2, pc}

call_DebugList:
        bl      DebugList
        ldmfd   sp!, {pc}           @ Mainloopreturn

@-------------------------------------------------------------------------
@ ǥХåѿꥹ <xxxx> 1$
@-------------------------------------------------------------------------
VarList:
        stmfd   sp!, {r0-r2, lr}

        mov     r2, #0x21
    1:  mov     r0, r2
        bl      OutChar
        mov     r0, #' '
        bl      OutChar
        ldr     r0, [fp, r2,LSL #2]
        bl      PrintHex8
        mov     r1, #12
        bl      PrintRight
        bl      NewLine
        add     r2, r2, #1
        cmp     r2, #0x7F
        blo     1b
        ldmfd   sp!, {r0-r2, pc}

call_VarList:
        bl      VarList
        ldmfd   sp!, {pc}           @ Mainloopreturn

@-------------------------------------------------------------------------
@ ǥХåѥץꥹ <xxxx> 1%
@-------------------------------------------------------------------------
DumpList:
        stmfd   sp!, {r0-r3, v1, lr}
        mov     r1, #'=             @ ץƬ
        ldr     r2, [fp, r1,LSL #2]
        and     r2, r2, #0xfffffff0 @ 16byteϤ
        mov     v1, #8
    1:  mov     r0, r2
        bl      PrintHex8           @ Ƭɥ쥹ɽ
        mov     r0, #' '
        bl      OutChar
        mov     r0, #':'
        bl      OutChar
        mov     r3, #16
    2:
        mov     r0, #' '
        bl      OutChar
        ldrb    r0, [r2], #1        @ 1Хɽ
        bl      PrintHex2
        subs    r3, r3, #1
        bne     2b
        bl      NewLine
        subs    v1, v1, #1
        bne     1b                  @ Խ
        ldmfd   sp!, {r0-r3, v1, pc}

call_DumpList:
        bl      DumpList
        ldmfd   sp!, {pc}           @ Mainloopreturn

@-------------------------------------------------------------------------
@ ǥХåѥ٥ꥹ <xxxx> 1&
@-------------------------------------------------------------------------
LabelList:
        stmfd   sp!, {lr}
        ldr     ip, LabelTable      @ ٥ơ֥Ƭ
        ldr     r2, TablePointer
        ldr     r3, [r2]            @ ơ֥ǽϿ
    1:
        cmp     ip, r3
        bhs     2f
        ldr     r0, [ip, #12]
        bl      PrintHex8
        mov     r0, #' '
        bl      OutChar
        mov     r0, ip
        bl      OutAsciiZ
        bl      NewLine
        add     ip, ip, #16
        b       1b
     2: ldmfd   sp!, {pc}

call_LabelList:
        bl      LabelList
        ldmfd   sp!, {pc}           @ Mainloopreturn
.endif

@-------------------------------------------------------------------------
@  Խ⡼
@  Mainloopcall
@       0) ֹ 0 ʤꥹ
@       1) ԤֹΤߤξϹԺ
@       2) ֹľ夬 - ʤֹʬꥹ
@       3) ֹľ夬 + ʤԿʬꥹ
@       4) ֹľ夬 ! ʤԽ
@       5) ƱֹιԤ¸ߤؤ
@       6) Ʊֹ椬ʤ
@-------------------------------------------------------------------------
EditMode:
        stmfd   sp!, {lr}
        bl      Decimal             @ ֹ
        tst     r0, r0              @ ֹ
        beq     List                @ ֹ 0 ʤꥹ
        cmp     v1, #0              @ ֹΤߤ
        bne     1f
        bl      LineDelete          @ Ժ
        ldmfd   sp!, {pc}           @ Mainloopreturn

    1:  cmp     v1, #'-'
        beq     List                @ ʬꥹ
        cmp     v1, #'+'
        beq     ListMore            @ ʬꥹ 20
.ifdef DEBUG
        cmp     v1, #'#'
        beq     call_DebugList      @ ǥХåѹԥꥹ[#]
        cmp     v1, #'$'
        beq     call_VarList        @ ǥХåѿꥹ[$]
        cmp     v1, #'%'
        beq     call_DumpList       @ ǥХåѥץꥹ[%]
        cmp     v1, #'&'
        beq     call_LabelList      @ ǥХåѥ٥ꥹ[&]
.endif
        cmp     v1, #'!'
        beq     LineEdit            @ Խ
        bl      LineSearch          @ ϺѤ߹ֹõ
        bcc     LineInsert          @ פԤʤ
        bl      LineDelete          @ ִ(Ժ+)

@-------------------------------------------------------------------------
@ 
@ r0 ֹ
@ v2 
@-------------------------------------------------------------------------
LineInsert:
        mov     r1, #0              @ ԤΥ׻
    1:  ldrb    r2, [v3, r1]        @ v3:ϥХåեƬ
        cmp     r2, #0              @ ?
        add     r1, r1, #1          @ ʸ
        bne     1b

        add     r1, r1, #12         @ 12=4+4+1+3
        and     r1, r1, #0xfffffffc @ 4Хȶ
        mov     ip, #'&             @ ҡƬ()
        ldr     r3, [fp, ip,LSL #2] @ ҡƬɥ쥹
        mov     r2, r3              @ ΥҡƬ
        add     r3, r3, r1          @ ҡƬ׻
        str     r3, [fp, ip,LSL #2] @ ҡƬ
        sub     v1, r2, v2          @ ưХȿ

        sub     r2, r2, #1          @ Ϥ old &-1 
        sub     r3, r3, #1          @ new &-1 ؤΥԡ

    2:
        ldrb    ip, [r2], #-1       @ ư
        strb    ip, [r3], #-1
        subs    v1, v1, #1          @ v1ХȰư
        bne     2b

        str     r1, [v2]            @ ԤؤΥեå
        str     r0, [v2, #4]        @ ֹ
        add     v2, v2, #8          @ 񤭹ֹ߰

    3:  ldrb    r2, [v3],#1         @ v3:ϥХåե
        strb    r2, [v2],#1         @ v2:
        cmp     r2, #0              @ ?
        bne     3b
        mov     v5, #1              @ ˹ EOL=yes
        ldmfd   sp!, {pc}           @ Mainloopreturn

@-------------------------------------------------------------------------
@ Ԥκ
@ r0 ˸ֹ
@-------------------------------------------------------------------------
LineDelete:
        stmfd   sp!, {r0, lr}
        bl      LineSearch          @ ϺѤ߹ֹõ
        bcc     2f                  @ פԤʤнλ
        mov     r0, v2              @ Ƭ
        ldr     r2, [v2]            @ ԥեåȼ
        add     r2, v2, r2          @ Ƭּ
        mov     r1, #'&             @ ҡƬ
        ldr     r3, [fp, r1,LSL #2]
        sub     v1, r3, r2          @ v1:ưХȿ
    1:
        ldrb    ip, [r2], #1        @ v1ХȰư
        strb    ip, [r0], #1
        subs    v1, v1, #1
        bne     1b
        str     r3, [fp, r1,LSL #2]
    2:
        mov     v5, #1              @ ˹ EOL=yes
        ldmfd   sp!, {r0, pc}       @ return

@-------------------------------------------------------------------------
@ ϺѤ߹ֹõ
@ r0 ˸ֹ桢r1, r2 ˲
@ ׹Ƭޤ԰פξˤϼ礭ֹƬ֤v2
@ Ʊֹ椬Х꡼å
@-------------------------------------------------------------------------
LineSearch:
        mov     r1, #'=             @ ץƬ
        ldr     v2, [fp, r1,LSL #2]
LineSearch_nextline:
    1:  ldr     r1, [v2]            @ ʤ鸡λ
        tst     r1, r1
        bmi     3f                  @ exit
        ldr     r2, [v2, #+4]       @ ֹ
        cmp     r0, r2
        beq     2f                  @ r0 = ܹr2
        blo     3f                  @ r0 < ܹr2
        add     v2, v2, r1          @ Ƭ (v2=v2+offset)
        b       1b
    2:  msr     cpsr_f, #0x20000000 @
        mov     pc, lr              @ return
    3:  msr     cpsr_f, #0x00000000 @
        mov     pc, lr              @ return

@-------------------------------------------------------------------------
@ 10ʸѴ
@ r0 ˿֤ͤ롢ͤʤ饭꡼å
@ 1 ʸɤ(v1)ǸƤФ졢1 ʸɤ(v1)֤
@-------------------------------------------------------------------------
Decimal:
        stmfd   sp!, {r1,r2, lr}
        mov     r2, #0              @ 
        mov     r0, #0
        mov     r1, #10
        cmp     v1, #'+
        beq     1f
        cmp     v1, #'-
        bne     2f                  @ Num
        mov     r2, #1              @ 
    1:
        bl      GetDigit
        bcs     4f                  @ Ǥʤ֤
        b       3f
    2:
        bl      IsNum
        bcs     4f                  @ Ǥʤ
        sub     v1, v1, #'0         @ ͤѴ

    3:
        mla     ip, r0, r1, v1      @ r0=r0*10+v1
        mov     r0, ip
        bl      GetDigit
        bcc     3b
        tst     r2, r2              @ 餫
        rsbne   r0, r0, #0          @ ˤ
        msreq   cpsr_f, #0x00       @ clear carry
    4:  ldmfd   sp!, {r1,r2, pc}    @ return

@-------------------------------------------------------------------------
@ ̵10ʿʸ v3 μ˽񤭹
@ r0 : 
@-------------------------------------------------------------------------
PutDecimal:
        stmfd   sp!, {r0-r2, lr}    @ push
        mov     r2, #0              @ counter
    1:  mov     r1, #10             @
        bl      udiv                @ division by 10
        add     r2, r2, #1          @ counter++
        stmfd   sp!, {r1}           @ least digit (reminder)
        cmp     r0, #0
        bne     1b                  @ done ?
    2:  ldmfd   sp!, {r0}           @ most digit
        add     r0, r0, #'0'        @ ASCII
        strb    r0, [v3], #1        @ output a digit
        subs    r2, r2, #1          @ counter--
        bne     2b
        ldmfd   sp!, {r0-r2, pc}    @ pop & return

@---------------------------------------------------------------------
@ v1 ʸɤΥå
@ ʤѴ v1 ֤. ʤ饭꡼å
@ ! 16ʿʸνä뤳
@---------------------------------------------------------------------

IsNum:  cmp     v1, #'0'            @ 0 - 9
        bcs     1f
        msr     cpsr_f, #0x20000000 @ set carry v1<'0'
        mov     pc, lr              @ return
    1:  cmp     v1, #':'            @ set carry v1>'9'
        mov     pc, lr              @ return

GetDigit:
        stmfd   sp!, {lr}
        bl      GetChar             @ 0 - 9
        bl      IsNum
        subcc   v1, v1, #'0'        @ Ѵ Cy=0
        ldmfd   sp!, {pc}

IsAlpha:
        stmfd   sp!, {lr}
        bl      IsAlpha1            @ ʸ?
        bcc     1f                  @ yes
        bl      IsAlpha2            @ Ѿʸ?
    1:  ldmfd   sp!, {pc}

IsAlpha1:
        cmp     v1, #'A             @ ʸ(A-Z)?
        bcs     1f
        msr     cpsr_f, #0x20000000 @ if v1<'A' Cy=1
        mov     pc, lr              @ return
    1:  cmp     v1, #'[             @ if v1>'Z' Cy=1
        mov     pc, lr              @ return

IsAlpha2:
        cmp     v1, #'a             @ Ѿʸ(a-z)?
        bcs     1f
        msr     cpsr_f, #0x20000000 @ if v1<'a' Cy=1
        mov     pc, lr              @ return
    1:  cmp     v1, #'z+1           @ if v1>'z' Cy=1
        mov     pc, lr              @ return

IsAlphaNum:
        stmfd   sp!, {lr}
        bl      IsAlpha             @ ʸ?
        bcc     1f                  @ yes
        bl      IsNum               @ ?
    1:  ldmfd   sp!, {pc}

@-------------------------------------------------------------------------
@ եɤ߹
@-------------------------------------------------------------------------
READ_FILE:
        stmfd   sp!, {lr}
        mov     ip, #0              @ ip=0
        ldr     r1, input_0         @ ϥХåեɥ쥹
    1:
        ldr     r0, [fp, #-8]       @ FileDesc
        mov     r2, #1              @ ɤߤߥХȿ
        swi     #sys_read           @ ե뤫ɤߤ
        tst     r0, r0
        beq     2f                  @ EOF ?

        ldrb     r0, [r1]
        cmp     r0, #10             @ LineFeed ?
        beq     3f
        add     r1, r1, #1          @ input++
        b       1b
    2:
        ldr     r0, [fp, #-8]       @ FileDesc
        bl      fclose              @ File Close
        strb    ip, [fp, #-4]       @ Read from console (0)
        bl      LoadCode            @ ưեͭ
        b       4f
    3:  mov     v5, ip              @ EOL=no
    4:  strb    ip, [r1]
        ldr     v3, input_0
        ldmfd   sp!, {pc}

input_0:    .long   input0                @ vtllib.sbssΥХåե

@-------------------------------------------------------------------------
@ ͽ ?
@-------------------------------------------------------------------------
Com_OutNum:
        stmfd   sp!, {lr}
        bl      GetChar             @ get next
        cmp     v1, #'='
        bne     1f
        bl      Exp                 @ PrintLeft
        bl      PrintLeft
        ldmfd   sp!, {pc}

    1:
        cmp     v1, #'*'            @ ̵10
        beq     on_unsigned
        cmp     v1, #'$'            @ ?$ 162
        beq     on_hex2
        cmp     v1, #'#'            @ ?# 164
        beq     on_hex4
        cmp     v1, #'?'            @ ?? 168
        beq     on_hex8
        mov     r3, v1
        bl      Exp
        and     r1, r0, #0xff       @ ɽ(MAX255)
        bl      SkipEqualExp        @ 1ʸɤФ ɾ
        cmp     r3, #'{'            @ ?{ 8ʿ
        beq     on_oct
        cmp     r3, #'!'            @ ?! 2nӥå
        beq     on_bin
        cmp     r3, #'('            @ ?( print right
        beq     on_dec_right
        cmp     r3, #'['            @ ?[ print right
        beq     on_dec_right0
        b       pop_and_Error       @ å SyntaxError

    on_unsigned:
        bl      SkipEqualExp        @ 1ʸɤФ ɾ
        bl      PrintLeftU
        ldmfd   sp!, {pc}
    on_hex2:
        bl      SkipEqualExp        @ 1ʸɤФ ɾ
        bl      PrintHex2
        ldmfd   sp!, {pc}
    on_hex4:
        bl      SkipEqualExp        @ 1ʸɤФ ɾ
        bl      PrintHex4
        ldmfd   sp!, {pc}
    on_hex8:
        bl      SkipEqualExp        @ 1ʸɤФ ɾ
        bl      PrintHex8
        ldmfd   sp!, {pc}
    on_oct:
        bl      PrintOctal
        ldmfd   sp!, {pc}
    on_bin:
        bl      PrintBinary
        ldmfd   sp!, {pc}
    on_dec_right:
        bl      PrintRight
        ldmfd   sp!, {pc}
    on_dec_right0:
        bl      PrintRight0
        ldmfd   sp!, {pc}

@-------------------------------------------------------------------------
@ ʸ $
@-------------------------------------------------------------------------
Com_OutChar:
        stmfd   sp!, {lr}
        bl      GetChar             @ get next
        cmp     v1, #'='
        beq     1f
        cmp     v1, #'$'            @ $$ 2byte
        beq     2f
        cmp     v1, #'#'            @ $# 4byte
        beq     4f
        cmp     v1, #'*'            @ $*=StrPtr
        beq     6f
        ldmfd   sp!, {pc}

    1:  bl      Exp                 @ 1Хʸ
        b       3f

    2:  bl      SkipEqualExp        @ 2Хʸ
        and     r1, r0, #0x00ff
        and     r2, r0, #0xff00
        mov     r0, r2, LSR #8      @ ̥ХȤ
        bl      OutChar
        mov     r0, r1
    3:  bl      OutChar
        ldmfd   sp!, {pc}

    4:  bl      SkipEqualExp        @ 4Хʸ
        mov     r1, r0
        mov     r2, #4
    5:  mov     r1, r1, ROR #24     @ = ROL #8
        and     r0, r1, #0xFF
        bl      OutChar
        subs    r2, r2, #1
        bne     5b
        ldmfd   sp!, {pc}

    6:  bl      SkipEqualExp
        bl      OutAsciiZ
        ldmfd   sp!, {pc}

@-------------------------------------------------------------------------
@  .=n
@-------------------------------------------------------------------------
Com_Space:
        stmfd   sp!, {lr}
        bl      SkipEqualExp        @ 1ʸɤФ ɾ
        mov     r1, r0
        mov     r0, #' '
    1:  bl      OutChar
        subs    r1, r1, #1
        bne     1b
        ldmfd   sp!, {pc}

@-------------------------------------------------------------------------
@ Խ /
@-------------------------------------------------------------------------
Com_NewLine:
        stmfd   sp!, {lr}
        bl      NewLine
        ldmfd   sp!, {pc}

@-------------------------------------------------------------------------
@ ʸ "
@-------------------------------------------------------------------------
Com_String:
        stmfd   sp!, {lr}
        mov     r1, #0
        mov     r0, v3
    1:  bl      GetChar
        cmp     v1, #'"'
        beq     2f
        cmp     v5, #1              @ EOL=yes ?
        beq     2f
        add     r1, r1, #1
        b       1b
    2:
        bl      OutString
        ldmfd   sp!, {pc}

@-------------------------------------------------------------------------
@ GOTO #
@-------------------------------------------------------------------------
Com_GO:
        stmfd   sp!, {lr}
        bl      GetChar
        cmp     v1, #'!'
        beq     2f                  @ #! ϥȡ԰ư
.ifdef VTL_LABEL
        bl      ClearLabel
.endif
        bl      SkipEqualExp2       @ = å ɾ
Com_GO_go:
        ldrb    r1, [fp, #-3]       @ ExecMode=Direct ?
        cmp     r1, #0
        beq     4f                  @ Directʤ٥

.ifdef VTL_LABEL
        mov     r1, #'^'            @ ƥѿ^פ
        ldr     r2, [fp, r1,LSL #2] @ å
        tst     r2, r2              @ ǥ٥뻲Ȥ뤫?
        beq     1f                  @ ̵Ϲֹ
        mov     v2, r0              @ v2 ԤƬɥ쥹
        mov     r0, #0              @ ƥѿ^ץꥢ
        str     r0, [fp, r1,LSL #2] @ ٥̵
        b       6f                  @ check
.endif

    1: @ ֹ
        tst     r0, r0              @ #=0 ʤ鼡
        bne     3f                  @ ֹ˥
    2: @ nextline
        mov     v5, #1              @ Ԥ˰ư  EOL=yes
        ldmfd   sp!, {pc}

    3: @ ֹ򸡺
        ldr     r1, [v2, #+4]       @ ߤιԤȹֹ
        cmp     r0, r1
        blo     5f                  @ Ƭ鸡
        bl      LineSearch_nextline @ ߹Ԥ鸡
        b       6f                  @ check

    4: @ label
.ifdef VTL_LABEL
        bl      LabelScan           @ ٥ơ֥
.endif

    5: @ top:
        bl      LineSearch          @ v2 ԤƬ
    6: @ check:
        ldr     r0, [v2]            @ å
        adds    r0, r0, #1
        beq     7f                  @ stop
        mov     r0, #1
        strb    r0, [fp, #-3]       @ ExecMode=Memory
        bl      SetLineNo           @ ֹ # 
        add     v3, v2, #8          @ Ƭ
        mov     v5, #0              @ EOL=no
        ldmfd   sp!, {pc}
    7: @ stop:
        bl      CheckCGI            @ CGI⡼ɤʤ齪λ
        bl      WarmInit1           @ ϥǥХѹʤ
        ldmfd   sp!, {pc}

.ifdef VTL_LABEL
@-------------------------------------------------------------------------
@ ǤΥ٥뻲ȷ̤򥯥ꥢ
@-------------------------------------------------------------------------
ClearLabel:
        mov     r1, #'^'            @
        mov     r0, #0              @ ƥѿ^ץꥢ
        str     r0, [fp, r1,LSL #2] @ ٥̵
        mov     pc, lr

@-------------------------------------------------------------------------
@ ɤ򥹥󤷤ƥ٥ȥ٥μιԥɥ쥹ơ֥Ͽ
@ ٥ơ֥16Хȡȥ4096(64KB)
@ 12ХȤASCIIZ(11ХȤΥ٥ʸ) + 4Х(Ƭɥ쥹)
@ r0-r3¸, v1,v2 
@-------------------------------------------------------------------------
LabelScan:
        stmfd   sp!, {r0-r3, lr}
        mov     r1, #'='
        ldr     v2, [fp, r1,LSL #2] @ Ƭɥ쥹
        ldr     v1, [v2]            @ ʤ齪λ
        adds    v1, v1, #1
        bne     1f                  @ Ǥʤ
        ldmfd   sp!, {r0-r3, pc}    @ ɤ
    1:
        ldr     r3, LabelTable      @ ٥ơ֥Ƭ
        ldr     r0, TablePointer
        str     r3, [r0]            @ ϿֳǼ

    2:
        mov     r1, #8              @ ƥƬ
    3:                              @ 򥹥å
        ldrb    v1, [v2, r1]        @ 1ʸ
        cmp     v1, #0
        beq     7f                  @ ʤ鼡
        cmp     v1, #' '            @ ɤФ
        bne     4f                  @ ٥Ͽ
        add     r1, r1, #1
        b       3b

    4: @ nextch
        cmp     v1, #'^'            @ ٥?
        bne     7f                  @ ٥Ǥʤ
       @ ٥Ͽ
        add     r1, r1, #1          @ ٥ʸƬ
        mov     r2, #0              @ ٥Ĺ
    5:
        ldrb    v1, [v2, r1]        @ 1ʸ
        cmp     v1, #0
        beq     6f                  @ 
        cmp     v1, #' '            @ ٥ζڤ϶
        beq     6f                  @ ٥ʸ
        cmp     r2, #11             @ 11ʸޤ
        beq     6f                  @ ʸ
        strb    v1, [r3, r2]        @ 1ʸϿ
        add     r1, r1, #1
        add     r2, r2, #1
        b       5b                  @ ʸ

    6: @ registerd
        mov     v1, #0
        strb    v1, [r3, r2]        @ ٥ʸ
        ldr     v1, [v2]            @ ԥեå
        add     v1, v2, v1          @ v1˼Ƭ
        str     v1, [r3, #12]       @ ɥ쥹Ͽ
        add     r3, r3, #16
        mov     v2, v1
        str     r3, [r0]            @ Ͽ(TablePointer)

    7:                              @ Խ
        ldr     v1, [v2]            @ ԥեå
        add     v2, v2, v1          @ v1˼Ƭ
        ldr     v1, [v2]            @ ԥեå
        adds    v1, v1, #1
        beq     8f                  @ λ
        cmp     r3, r0              @ ơ֥ǽ
        beq     8f                  @ λ
        b       2b                  @ Ԥν򷫤֤

    8: @ finish:
        ldmfd   sp!, {r0-r3, pc}

@-------------------------------------------------------------------------
@ ơ֥뤫٥μιԥɥ쥹
@ ٥μιԤƬɥ쥹 r1 ȡ^פꡢv1˼ʸ
@ ֤롣Factor v3 ^μꤷƸƤФ
@ v3 ϥ٥θ(ĹɤФ)ꤵ
@ r0, r2, r3, ip ˲
@-------------------------------------------------------------------------
LabelSearch:
        stmfd   sp!, {lr}
        ldr     r3, LabelTable      @ ٥ơ֥Ƭ
        ldr     r0, TablePointer
        ldr     r1, [r0]            @ ơ֥ǽϿ

    1:
        mov     r2, #0              @ ٥Ĺ
    2:
        ldrb    v1, [v3, r2]        @ 
        ldrb    ip, [r3, r2]        @ ơ֥
        tst     ip, ip              @ ơ֥ʸκǸ?
        bne     3f                  @ Ӥ³
        bl      IsAlphaNum
        bcs     4f                  @ v1=space, ip=0

    3:  @ ۤʤ
        cmp     v1, ip              @ 
        bne     5f                  @ פʤϼΥ٥
        add     r2, r2, #1          @ פ鼡ʸ
        cmp     r2, #11             @ ĹΥå
        bne     2b                  @ ʸ
        bl      Skip_excess         @ Ĺ᤮٥ϸɤФ

    4:  @ found
        ldr     r1, [r3, #12]       @ ơ֥뤫饢ɥ쥹
        mov     r0, #'^'            @ ƥѿ^פ
        str     r1, [fp, r0,LSL #2] @ ٥μƬ
        add     v3, v3, r2
        bl      GetChar
        msr     cpsr_f, #0x00000000 @ ĤХ꡼ꥢ
        ldmfd   sp!, {pc}

    5:  @ next
        add     r3, r3, #16
        cmp     r3, r1              @ ơ֥κǽȥ
        beq     6f                  @ Ĥʤ
        cmp     r3, r0              @ ơ֥ΰǽ?
        beq     6f                  @
        b       1b                  @ Υơ֥륨ȥ

    6:  @ not found:
        mov     r2, #0
        bl      Skip_excess         @ ٥򤫹ޤФ
@        mvn     r1, #0x00000000     @ r1 -1֤
        mov     r1, #0
        msr     cpsr_f, #0x20000000 @ ʤХ꡼å
        ldmfd   sp!, {pc}

Skip_excess:
        stmfd   sp!, {lr}
    1:  ldrb    v1, [v3, r2]        @ Ĺ᤮٥ϥå
        bl      IsAlphaNum
        bcs     2f                  @ ѿʳ
        add     r2, r2, #1          @ ɤ߹ֹ߰
        b       1b
    2:  ldmfd   sp!, {pc}

.endif

@-------------------------------------------------------------------------
@ = Ƭɥ쥹
@-------------------------------------------------------------------------
Com_Top:
        stmfd   sp!, {lr}
        bl      SkipEqualExp        @ = ɤФ ɾ
        mov     r3, r0
        bl      RangeCheck          @ ',' <= '=' < '*'
        blo     4f                  @ ϰϳ顼
        mov     r1, #'='            @ Ƭ
        str     r3, [fp, r1,LSL #2] @ ͤ= ==r3
        mov     r1, #'*'            @ 
        ldr     r2, [fp, r1,LSL #2] @ r2=*
    1: @ nextline:                  @ 
        ldr     r0, [r3]            @ ԤؤΥեå
        adds    r1, r0, #1          @ Ƭ -1 ?
        beq     2f                  @ yes
        tst     r0, r0
        ble     3f                  @ ԤؤΥեå <= 0 
        ldr     r1, [r3, #4]        @ ֹ > 0
        tst     r1, r1
        ble     3f                  @ ֹ <= 0 
        add     r3, r3, r0          @ Ƭɥ쥹
        cmp     r2, r3              @ Ƭ > 
        ble     3f                  @
        b       1b                  @ Խ
    2: @ found:
        mov     r2, r0              @ ȯ
        b       Com_NEW_set_end     @ & 
    3: @ endmark_err:
        adr     r0, EndMark_msg     @ ץ̤
        bl      OutAsciiZ
        bl      WarmInit            @
        ldmfd   sp!, {pc}

    4: @ range_err
        bl      RangeError
        ldmfd   sp!, {pc}

EndMark_msg:
        .asciz   "\n&=0 required.\n"
        .align   2

@-------------------------------------------------------------------------
@ ޡȶƬ &
@   = (ΰƬ)ͤǻ, Хɥ쥹ꤵ
@-------------------------------------------------------------------------
Com_NEW:
        stmfd   sp!, {lr}
        bl      SkipEqualExp        @ = ɤФ ɾ
        mov     r1, #'='            @ Ƭ
        ldr     r2, [fp, r1,LSL #2] @ &==+4
        mvn     r0, #0              @ ޡ(-1)
        str     r0, [r2]            @ ޡ
Com_NEW_set_end:
        add     r2, r2, #4          @ μ
        mov     r1, #'&'            @ Ƭ
        str     r2, [fp, r1,LSL #2] @
        bl      WarmInit1           @ ϥǥХѹʤ
        ldmfd   sp!, {pc}

@-------------------------------------------------------------------------
@ BRK *
@    ǽ֤, brk
@-------------------------------------------------------------------------
Com_BRK:
        stmfd   sp!, {lr}
        bl      SkipEqualExp        @ = ɤФ ɾ
        swi     #sys_brk            @ 
        mov     r1, #'*'            @ ҡƬ
        str     r0, [fp, r1,LSL #2]
        ldmfd   sp!, {pc}

@-------------------------------------------------------------------------
@ RANDOM '
@     /dev/urandom ɬץХȿɤ߽Ф
@    /usr/src/linux/drivers/char/random.c 
@-------------------------------------------------------------------------
Com_RANDOM:
        stmfd   sp!, {lr}
        bl      SkipEqualExp        @ = ɤФ ɾ
        mov     r1, #'`'            @ 
        str     r0, [fp, r1,LSL #2]
        bl      sgenrand
        ldmfd   sp!, {pc}

@-------------------------------------------------------------------------
@ ϰϥåե饰 [
@-------------------------------------------------------------------------
Com_RCheck:
        stmfd   sp!, {lr}
        bl      SkipEqualExp        @ = ɤФ ɾ
        mov     r1, #'['            @ ϰϥå
        str     r0, [fp, r1,LSL #2]
        ldmfd   sp!, {pc}

@-------------------------------------------------------------------------
@ ѿޤϼ򥹥å¸
@-------------------------------------------------------------------------
Com_VarPush:
        stmfd   sp!, {lr}
        ldr     r2, [fp, #-16]      @ VSTACK
        mov     r3, #VSTACKMAX
        sub     r3, r3, #1          @ r3 = VSTACKMAX - 1
    1: @ next
        cmp     r2, r3
        bhi     VarStackError_over
        bl      GetChar
        cmp     v1, #'='            @ +=
        bne     2f
        bl      Exp
        add     r1, fp, #1024       @ [fp+r2*4+1024]
        str     r0, [r1, r2,LSL #2] @ ѿå˼¸
        add     r2, r2, #1
        b       3f
    2: @ push2
        cmp     v1, #' '
        beq     3f
        cmp     v5 , #1             @ EOL=yes?
        beq     3f
        ldr     r0, [fp, v1,LSL #2] @ ѿͼ
        add     r1, fp, #1024       @ [fp+r2*4+1024]
        str     r0, [r1, r2,LSL #2] @ ѿå˼¸
        add     r2, r2, #1
        b       1b                  @ ѿ
    3: @ exit
        str     r2, [fp, #-16]      @ åݥ󥿹
        ldmfd   sp!, {pc}

@-------------------------------------------------------------------------
@ ѿ򥹥å
@-------------------------------------------------------------------------
Com_VarPop:
        stmfd   sp!, {lr}
        ldr     r2, [fp, #-16]      @ VSTACK
    1: @ next:
        bl      GetChar
        cmp     v1, #' '
        beq     2f
        cmp     v5 , #1             @ EOL=yes?
        beq     2f
        subs    r2, r2, #1
        bmi     VarStackError_under
        add     r1, fp, #1024       @ [fp+r2*4+1024]
        ldr     r0, [r1, r2,LSL #2] @ ѿå
        str     r0, [fp, v1,LSL #2] @ ѿ
        b       1b
    2: @ exit:
        str     r2, [fp, #-16]      @ åݥ󥿹
        ldmfd   sp!, {pc}

@-------------------------------------------------------------------------
@ եǼƬ v4
@-------------------------------------------------------------------------
Com_FileTop:
        stmfd   sp!, {lr}
        bl      SkipEqualExp        @ = ɤФ ɾ
        mov     v4, r0
        bl      RangeCheck          @ ϰϥå
        bcs     1f                  @ Com_FileEnd:1 ϰϳ򥢥
        mov     r1, #'{'            @ եǼƬ
        str     r0, [fp, r1,LSL #2]
        ldmfd   sp!, {pc}

@-------------------------------------------------------------------------
@ եǼǽ v4
@-------------------------------------------------------------------------
Com_FileEnd:
        stmfd   sp!, {lr}
        bl      SkipEqualExp        @ = ɤФ ɾ
        mov     v4, r0
        bl      RangeCheck          @ ϰϥå
        bcs     1f                  @ ϰϳ򥢥
        mov     r1, #'}'            @ եǼƬ
        str     r0, [fp, r1,LSL #2]
        ldmfd   sp!, {pc}
    1: @ range_err
        bl      RangeError
        ldmfd   sp!, {pc}

@-------------------------------------------------------------------------
@ CodeWrite <=
@-------------------------------------------------------------------------
Com_CdWrite:
        stmfd   sp!, {lr}
        bl      GetFileName
        bl      fwopen              @ open
        beq     4f                  @ exit
        bmi     5f                  @ error
        str     r0, [fp, #-12]      @ FileDescW
        mov     r1, #'='
        ldr     r3, [fp, r1,LSL #2] @ Ƭɥ쥹
        stmfd   sp!, {v3}

    1: @ loop
        ldr     v3, input2          @ ꥢ()
        ldr     r0, [r3]            @ ԤؤΥեå
        adds    r0, r0, #1          @ ɺǽ?
        beq     4f                  @ ǽʤ齪λ
        ldr     r0, [r3, #4]        @ ֹ
        bl      PutDecimal          @ r0ιֹv3˽񤭹
        mov     r0, #' '            @ ڡ
        strb    r0, [v3], #1        @ Write One Char
        mov     r1, #8
    2: @ code:
        ldrb    r0, [r3, r1]        @ ʬ񤭹
        cmp     r0, #0              @ ?
        beq     3f                  @ fileϸ弡
        strb    r0, [v3], #1        @ Write One Char
        add     r1, r1, #1
        b       2b

    3: @ next:
        ldr     r1, [r3]            @ ԥեå
        add     r3, r3, r1          @ Ƭ
        mov     r0, #10
        strb    r0, [v3], #1        @ Խ
        mov     r0, #0
        strb    r0, [v3]            @ EOL

        ldr     r0, input2          @ Хåեɥ쥹
        bl      StrLen              @ r0ʸĹr1֤
        mov     r2, r1              @ 񤭤ߥХȿ
        mov     r1, r0              @ Хåեɥ쥹
        ldr     r0, [fp, #-12]      @ FileDescW
        swi     #sys_write          @ ƥॳ
        b       1b                  @ Խ
    4: @ exit:
        ldmfd   sp!, {v3}
        ldr     r0, [fp, #-12]      @ FileDescW
        bl      fclose              @ ե륯
        mov     v5, #1              @ EOL=yes
        ldmfd   sp!, {pc}

    5: @ error:
        b       pop_and_Error

@-------------------------------------------------------------------------
@ CodeRead >=
@-------------------------------------------------------------------------
Com_CdRead:
        stmfd   sp!, {lr}
        ldrb    r0, [fp, #-4]
        cmp     r0, #1              @ Read from file
        beq     2f
        bl      GetFileName
        bl      fropen              @ open
        beq     1f
        bmi     SYS_Error
        str     r0, [fp, #-8]       @ FileDesc
        mov     r1, #1
        strb    r1, [fp, #-4]       @ Read from file
        mov     v5, r1              @ EOL
    1: @ exit
        ldmfd   sp!, {pc}
    2: @ error
        adr     r0, error_cdread
        bl      OutAsciiZ
        b       SYS_Error_return

error_cdread:   .asciz   "\nCode Read (>=) is not allowed!\n"
                .align   2

@-------------------------------------------------------------------------
@ ̤ޥɽ(顼ȥå)
@-------------------------------------------------------------------------
pop_and_SYS_Error:
        add     sp, sp, #4          @ å
SYS_Error:
        bl      CheckError
SYS_Error_return:
        add     sp, sp, #4          @ å
        bl      WarmInit
        b       MainLoop

@-------------------------------------------------------------------------
@ ƥॳ륨顼å
@-------------------------------------------------------------------------
CheckError:
        stmfd   sp!, {r0-r1,lr}
        mov     r1, #'|'            @ ֤ͤ | 
        str     r0, [fp, r1,LSL #2]
.ifdef  DETAILED_MSG
        bl      SysCallError
.else
        tst     r0, r0
        bpl     1f
        adr     r0, Error_msg
        bl      OutAsciiZ
.endif
    1:  ldmfd   sp!, {r0-r1, pc}

Error_msg:      .asciz   "\nError!\n"
                .align   2

@-------------------------------------------------------------------------
@ FileWrite (=
@-------------------------------------------------------------------------
Com_FileWrite:
        stmfd   sp!, {lr}
        ldrb    v1, [v3]            @ check (*=\0
        cmp     v1, #'*
        bne     1f
        bl      GetChar
        bl      GetChar
        cmp     v1, #'='
        bne     pop_and_Error
        bl      Exp                 @ Get argument
        b       2f                  @ open

    1:  bl      GetFileName
    2:  bl      fwopen              @ open
        beq     3f
        bmi     SYS_Error
        str     r0, [fp, #-12]      @ FileDescW

        mov     r2, #'{'            @ ǼΰƬ
        ldr     r1, [fp, r2,LSL #2] @ Хåե
        mov     r2, #'}'            @ Ǽΰǽ
        ldr     r3, [fp, r2,LSL #2] @
        cmp     r3, r1
        blo     3f
        sub     r2, r3, r1          @ 񤭹ߥ
        ldr     r0, [fp, #-12]      @ FileDescW
        swi     #sys_write          @ ƥॳ
        bl      fclose
    3: @ exit:
        ldmfd   sp!, {pc}

@-------------------------------------------------------------------------
@ FileRead )=
@-------------------------------------------------------------------------
Com_FileRead:
        stmfd   sp!, {lr}
        ldrb    v1, [v3]            @ check )*=\0
        cmp     v1, #'*
        bne     1f
        bl      GetChar
        bl      GetChar
        cmp     v1, #'='
        bne     pop_and_Error
        bl      Exp                 @ Get argument
        b       2f                  @ open

    1:  bl      GetFileName
    2:  bl      fropen              @ open
        beq     3f
        bmi     SYS_Error
        str     r0, [fp, #-12]      @ 裱 : fd
        mov     r1, #0              @ 裲 : offset = 0
        mov     r2, #SEEK_END       @ 裳 : origin
        swi     #sys_lseek          @ ե륵

        mov     r3, r0              @ file_size 
        ldr     r0, [fp, #-12]      @ 裱 : fd
        mov     r1, #0              @ 裲 : offset=0
        mov     r2, r1              @ 裳 : origin=0
        swi     #sys_lseek          @ եƬ˥

        mov     r0, #'{'            @ ǼΰƬ
        ldr     r1, [fp, r0,LSL #2] @ Хåե
        mov     r0, #')'
        str     r3, [fp, r0,LSL #2] @ ɤ߹ߥ
        add     r2, r1, r3          @ ǽɥ쥹׻
        mov     r0, #'}'
        str     r2, [fp, r0,LSL #2] @ Ǽΰǽ
        mov     r0, #'*'
        ldr     r3, [fp, r0,LSL #2] @ RAM
        cmp     r3, r1
        blo     3f                  @ r3<r1 ΰ­顼

        ldr     r0, [fp, #-12]      @ FileDescW
        swi     #sys_read           @ եΤɤߤ
        mov     r2, r0
        ldr     r0, [fp, #-12]      @ FileDescW
        bl      fclose
        tst     r2, r2              @ Read Error
        bmi     SYS_Error
    3: @ exit
        ldmfd   sp!, {pc}

@-------------------------------------------------------------------------
@
@-------------------------------------------------------------------------
@==============================================================
                .align   2
ipipe:          .long   ipipe0
opipe:          .long   opipe0
ipipe2:         .long   ipipe20
opipe2:         .long   opipe20

input2:         .long   input20
pid:            .long   pid0
FOR_direct:     .long   FOR_direct0
ExpError:       .long   ExpError0
ZeroDiv:        .long   ZeroDiv0
SigInt:         .long   SigInt0
VSTACK:         .long   VSTACK0
FileDescW:      .long   FileDescW0
FileDesc:       .long   FileDesc0
ReadFrom:       .long   ReadFrom0
ExecMode:       .long   ExecMode0
EOL:            .long   EOL0
LSTACK:         .long   LSTACK0
VarStack:       .long   VarStack0

.ifdef VTL_LABEL
LabelTable:     .long   LabelTable0
TablePointer:   .long   TablePointer0
.endif


@-------------------------------------------------------------------------
@ λ
@-------------------------------------------------------------------------
Com_Exit:       @   7E  ~  VTLλ
                bl      RESTORE_TERMIOS
                b       Exit

@-------------------------------------------------------------------------
@ 桼ĥޥɽ
@-------------------------------------------------------------------------
Com_Ext:
        stmfd   sp!, {lr}
.ifndef SMALL_VTL
.include        "ext.s"
func_err:
@        b       pop_and_Error
.endif
        ldmfd   sp!, {pc}

@-------------------------------------------------------------------------
@ ForkExec , ץμ¹
@-------------------------------------------------------------------------
Com_Exec:
.ifndef SMALL_VTL
        stmfd   sp!, {lr}
        bl      GetChar             @ skip =
        cmp     v1, #'*
        bne     0f
        bl      SkipEqualExp
        bl      GetString2
        b       3f
    0:  bl      GetChar             @ skip "
        cmp     v1, #'"'
        subne   v3, v3, #1          @ ungetc 1ʸ᤹
    1:
        bl      GetString           @ ץ̾
        ldr     r0, FileName2       @ ե̾ɽ
        @ bl      OutAsciiZ
        bl      NewLine

    3:  stmfd   sp!, {v1-v4}
        bl      ParseArg            @ ޥɹԤβ
        mov     v2, r1              @ 쥯ե̾
        add     r3, r3, #1          @ ҥץο
        ldr     r2, exarg2          @ char ** argp
        mov     v4, #0              @ Ƭץ
        cmp     r3, #1
        bhi     2f                  @ ѥפɬ

        @ ѥפξ
        swi     #sys_fork           @ ƥॳ
        tst     r0, r0
        beq     child               @ pid  0 ʤҥץ
        b       6f

    2:  @ ѥפɬ
        ldr     v3, ipipe           @ ѥפ򥪡ץ
        mov     r0, v3              @ v3  pipe_fd Ƭ
        swi     #sys_pipe           @ pipe ƥॳ

        @------------------------------------------------------------
        @ fork
        @------------------------------------------------------------
        swi     #sys_fork           @ ƥॳ
        tst     r0, r0
        beq     child               @ pid  0 ʤҥץ

        @------------------------------------------------------------
        @ ƥץ¦ν
        @------------------------------------------------------------
        tst     v4, v4              @ Ƭץ?
        blne    close_old_pipe      @ ƬǤʤХѥץ
        ldr     ip, [v3]            @ ѥ fd ΰư
        str     ip, [v3, #+8]
        ldr     ip, [v3, #+4]
        str     ip, [v3, #+12]
        subs    r3, r3, #1          @ Ĥҥץο
        beq     5f                  @ λ

    4:  add     r2, r2, #4          @ Υޥʸõ
        ldr     ip, [r2]
        cmp     ip, #0              @ ޥɶڤõ
        bne     4b
        add     r2, r2, #4          @ Υޥʸ
        add     v4, v4, #1          @ ƬץǤϤʤ
        b       2b

    5:  bl      close_new_pipe
    6:  @ λԤ r0=Ǹ˵ưҥץpid
        ldr     r1, stat_addr
        mov     r2, #WUNTRACED      @ WNOHANG
        ldr     r3, ru              @ rusage
        swi     #sys_wait4          @ ƥॳ
        bl      SET_TERMIOS         @ ҥץ
        ldmfd   sp!, {v1-v4}
        ldmfd   sp!, {pc}

        @------------------------------------------------------------
        @ ҥץ¦ν execve¹Ԥʤ
        @------------------------------------------------------------
child:
        bl      RESTORE_TERMIOS
        subs    r3, r3, #1          @ ǽץå
        bne     pipe_out            @ ǽץǤʤ
        tst     v2, v2              @ 쥯Ȥ뤫
        beq     pipe_in             @ 쥯̵, ɸ
        mov     r0, v2              @ 쥯ե̾
        bl      fwopen              @ r0 = ץ󤷤 fd
        mov     ip, r0
        mov     r1, #1              @ ɸϤե˺ؤ
        swi     #sys_dup2           @ dup2 ƥॳ
        mov     r0, ip
        bl      fclose              @ r0 ˤϥץ󤷤fd
        b       pipe_in

pipe_out:                           @ ɸϤѥפ
        ldr     r0, [v3, #+4]       @ ѥפν fd
        mov     r1, #1              @ ɸ
        swi     #sys_dup2           @ dup2 ƥॳ
        bl      close_new_pipe

pipe_in:
        tst     v4, v4              @ Ƭץʤ饹å
        beq     execve
                                    @ ɸϤѥפ
        ldr     r0, [v3, #+8]       @ ΥѥפɽФ fd
        mov     r1, #0              @ new_fd ɸ
        swi     #sys_dup2           @ dup2 ƥॳ
        bl      close_old_pipe

execve:
        ldr     r0, [r2]            @ char * filename exarg[0]
        mov     r1, r2              @ char **argp     exarg[1]
        ldr     r2, exarg2          @
        ldr     r2, [r2, #-12]      @ char ** envp
        swi     #sys_execve         @ ƥॳ
        bl      CheckError          @ ʤ餳ˤʤ
        bl      Exit                @ ñʤ

close_new_pipe:
        stmfd   sp!, {r0, lr}
        ldr     r0, [v3, #+4]       @ ϥѥפ򥯥
        bl      fclose
        ldr     r0, [v3]            @ ϥѥפ򥯥
        bl      fclose
        ldmfd   sp!, {r0, pc}

close_old_pipe:
        stmfd   sp!, {r0, lr}
        ldr     r0, [v3, #+12]      @ ϥѥפ򥯥
        bl      fclose
        ldr     r0, [v3, #+8]       @ ϥѥפ򥯥
        bl      fclose
        ldmfd   sp!, {r0, pc}
.endif

FileName2:      .long   FileName0
exarg2:         .long   exarg0
ru:             .long   ru0
stat_addr:      .long   stat_addr0

@-------------------------------------------------------------------------
@ execve Ѥΰ
@ ޥʸΥХåե FileName AsciiZѴƥݥ󥿤
@ r3  ѥפο (ҥץ-1) ֤
@ r1 ˥쥯ե̾ʸؤΥݥ󥿤֤
@-------------------------------------------------------------------------
ParseArg:
        stmfd   sp!, {v2, v3, lr}
        mov     r2, #0              @ 󥤥ǥå
        mov     r3, #0              @ ѥפΥ
        mov     r1, #0              @ 쥯ȥե饰
        ldr     v3, FileName2       @ ޥʸΥХåե
        ldr     v2, exarg2          @ ݥ󥿤Ƭ
    1:
        ldrb    r0, [v3]            @ Ϣ³Υå
        tst     r0, r0              @ å
        beq     pa_exit
        cmp     r0, #' '
        bne     2f                  @ ѥפΥå
        add     v3, v3, #1          @ ʤ鼡ʸ
        b       1b

    2:  cmp     r0, #'|'            @ ѥ?
        bne     3f
        add     r3, r3, #1          @ ѥפΥ+1
        bl      end_mark            @ null pointer
        b       6f

    3:  cmp     r0, #'>'            @ 쥯?
        bne     4f
        mov     r1, #1              @ 쥯ȥե饰
        bl      end_mark            @ null pointer
        b       6f

    4:  str     v3, [v2, r2,LSL #2] @ ؤΥݥ󥿤Ͽ
        add     r2, r2, #1          @ 󥤥ǥå+1

    5:  ldrb    r0, [v3]            @ õ
        tst     r0, r0              @ å
        beq     7f                  @ ʤ齪λ
        cmp     r0, #' '
        addne   v3, v3, #1
        bne     5b                  @ Ǥʤмʸ
        mov     r0, #0
        strb    r0, [v3]            @ ڡ 0 ִ
        tst     r1, r1              @ 쥯ȥե饰
        bne     7f                  @ > θϥե̾Τ

    6:  add     v3, v3, #1
        cmp     r2, #ARGMAX         @ ĿåƼ
        bhs     pa_exit
        b       1b

    7:  tst     r1, r1              @ 쥯ȥե饰
        beq     pa_exit
        sub     r2, r2, #1
        ldr     r1, [v2, r2,LSL #2]
        add     r2, r2, #1
pa_exit:
        mov     r0, #0
        str     r0, [v2, r2,LSL #2] @ ݥκǸ
        ldmfd   sp!, {v2, v3, pc}

end_mark:
        mov     r0, #0
        str     r0, [v2, r2,LSL #2] @ ޥɤζڤ NullPtr
        add     r2, r2, #1          @ 󥤥ǥå
        mov     pc, lr

@-------------------------------------------------------------------------
@ Ȥ߹ߥޥɤμ¹
@-------------------------------------------------------------------------
Com_Function:
.ifndef SMALL_VTL
        stmfd   sp!, {lr}
        bl      GetChar             @ | μʸ
func_c:
        cmp     v1, #'c'
        bne     func_d
        bl      def_func_c          @ |c
        ldmfd   sp!, {pc}
func_d:
func_e:
        cmp     v1, #'e'
        bne     func_f
        bl      def_func_e          @ |e
        ldmfd   sp!, {pc}
func_f:
        cmp     v1, #'f'
        bne     func_l
        bl      def_func_f          @ |f
        ldmfd   sp!, {pc}
func_l:
        cmp     v1, #'l'
        bne     func_m
        bl      def_func_l          @ |l
        ldmfd   sp!, {pc}
func_m:
        cmp     v1, #'m'
        bne     func_n
        bl      def_func_m          @ |m
        ldmfd   sp!, {pc}
func_n:
func_p:
        cmp     v1, #'p'
        bne     func_q
        bl      def_func_p          @ |p
        ldmfd   sp!, {pc}
func_q:
func_r:
        cmp     v1, #'r'
        bne     func_s
        bl      def_func_r          @ |r
        ldmfd   sp!, {pc}
func_s:
        cmp     v1, #'s'
        bne     func_t
        bl      def_func_s          @ |s
        ldmfd   sp!, {pc}
func_t:
func_u:
        cmp     v1, #'u'
        bne     func_v
        bl      def_func_u          @ |u
        ldmfd   sp!, {pc}
func_v:
        cmp     v1, #'v'
        bne     func_z
        bl      def_func_v          @ |u
        ldmfd   sp!, {pc}
func_z:
        cmp     v1, #'z'
        bne     pop_and_Error
        bl      def_func_z          @ |z
        ldmfd   sp!, {pc}

@-------------------------------------------------------------------------
@ Ȥ߹ߴؿѥå
@-------------------------------------------------------------------------
                .align  2
    msg_f_ca:   .asciz  ""
                .align  2
    msg_f_cd:   .asciz  "Change Directory to "
                .align  2
    msg_f_cm:   .asciz  "Change Permission \n"
                .align  2
    msg_f_cr:   .asciz  "Change Root to "
                .align  2
    msg_f_cw:   .asciz  "Current Working Directory : "
                .align  2
    msg_f_ex:   .asciz  "Exec Command\n"
                .align  2
@-------------------------------------------------------------------------

@------------------------------------
@ |c ǻϤޤȤ߹ߥޥ
@------------------------------------
def_func_c:
        stmfd   sp!, {lr}
        bl      GetChar             @
        cmp     v1, #'a'
        beq     func_ca             @ cat
        cmp     v1, #'d'
        beq     func_cd             @ cd
        cmp     v1, #'m'
        beq     func_cm             @ chmod
        cmp     v1, #'r'
        beq     func_cr             @ chroot
        cmp     v1, #'w'
        beq     func_cw             @ pwd
        b       pop2_and_Error
func_ca:
        adr     r0, msg_f_ca        @ |ca file
        bl      FuncBegin
        ldr     r0, [r1]            @ filename
        bl      DispFile
        ldmfd   sp!, {pc}
func_cd:
        adr     r0, msg_f_cd        @ |cd path
        bl      FuncBegin
        ldr     r1, [r1]            @ char ** argp
        ldr     r0, FileName2
        bl      OutAsciiZ
        bl      NewLine
        swi     #sys_chdir          @ ƥॳ
        bl      CheckError
        ldmfd   sp!, {pc}
func_cm:
        adr     r0, msg_f_cm        @ |cm 644 file
        bl      FuncBegin
        ldr     r0, [r1, #4]        @ file name
        ldr     r1, [r1]            @ permission
        bl      Oct2Bin
        mov     r1, r0
        swi     #sys_chmod          @ ƥॳ
        bl      CheckError
        ldmfd   sp!, {pc}
func_cr:
        adr     r0, msg_f_cr        @ |cr path
        bl      FuncBegin
        ldr     r1, [r1]            @ char ** argp
        ldr     r0, FileName2
        bl      OutAsciiZ
        bl      NewLine
        swi     #sys_chroot         @ ƥॳ
        bl      CheckError
        ldmfd   sp!, {pc}
func_cw:
        adr     r0, msg_f_cw        @ |cw
        bl      OutAsciiZ
        ldr     r0, FileName2
        mov     r3, r0              @ save r0
        mov     r1, #FNAMEMAX
        swi     #sys_getcwd         @ ƥॳ
        bl      CheckError
        mov     r0, r3              @ restore r0
        bl      OutAsciiZ
        bl      NewLine
        ldmfd   sp!, {pc}

@------------------------------------
@ |e ǻϤޤȤ߹ߥޥ
@------------------------------------
def_func_e:
        stmfd   sp!, {lr}
        bl      GetChar             @
        cmp     v1, #'x'
        beq     func_ex             @ execve
        b       pop2_and_Error
func_ex:
        adr     r0, msg_f_ex        @ |ex file arg ..
        bl      RESTORE_TERMIOS     @ ü᤹
        bl      FuncBegin           @ r1: char ** argp
        ldr     r0, [r1]            @ char * filename
        ldr     r2, exarg2          @
        ldr     r2, [r2, #-12]      @ char ** envp
        swi     #sys_execve         @ ƥॳ
        bl      CheckError          @ ʤ餳ˤʤ
        bl      SET_TERMIOS         @ üΥ륨OFF
        ldmfd   sp!, {pc}

@------------------------------------
@ |f ǻϤޤȤ߹ߥޥ
@------------------------------------
def_func_f:
.ifdef FRAME_BUFFER
.include        "vtlfb.s"
.endif

@------------------------------------
@ |l ǻϤޤȤ߹ߥޥ
@------------------------------------
def_func_l:
        stmfd   sp!, {lr}
        bl      GetChar             @
        cmp     v1, #'s'
        beq     func_ls            @ ls
        b       pop2_and_Error

func_ls:
        adr     r0, msg_f_ls        @ |ls dir
        bl      FuncBegin
        ldr     r2, [r1]
        tst     r2, r2
        bne     1f
        adrl    r2, current_dir     @ dir ʤ
    1:  ldr     r3, DirName2
        mov     r0, r3
    2:  ldrb    ip, [r2], #1        @ dir 򥳥ԡ
        strb    ip, [r3], #1
        tst     ip, ip
        bne     2b
        ldrb    ip, [r3, #-2]       @ dir/å
        mov     r2, #'/
        cmp     ip, r2
        beq     3f                  @ / ͭ
        strb    r2, [r3, #-1]       @ / 񤭹
        mov     r2, #0
        strb    r2, [r3]            @ end mark
    3:
        bl      fropen
        bmi     6f                  @ 顼åƽλ
        stmfd   sp!, {v1, v2, v6}
        mov     v2, r0              @ fd ¸
        ldr     v6, DirName2        @ for GetFileStat
    4:  @ ǥ쥯ȥꥨȥ
        @ unsigned int fd, void * dirent, unsigned int count
        mov     r0, v2              @ fd 
        ldr     r1, dir_ent2        @ ХåեƬ
        mov     v1, r1              @ v1 : struct top (dir_ent)
        ldr     r2, size_dir_ent2
        swi     #sys_getdents       @ ƥॳ
        tst     r0, r0              @ valid buffer length
        bmi     6f
        beq     7f
        mov     r3, r0              @ r3 : buffer size

    5:  @ dir_entե
        mov     r1, v1              @ v1 : dir_ent
        bl      GetFileStat         @ r1:dir_entɥ쥹
        ldr     r2, file_stat2
        ldrh    r0, [r2, #+8]       @ file_stat.st_mode
        mov     r1, #6
        bl      PrintOctal          @ mode
        ldr     r0, [r2, #+20]      @ file_stat.st_size ?+2?
        mov     r1, #12
        bl      PrintRight          @ file size
        mov     r0, #' '
        bl      OutChar
        add     r0, v1, #10         @ dir_ent.filename
        bl      OutAsciiZ           @ filename
        bl      NewLine
        ldrh    r0, [v1, #+8]       @ record length
        subs    r3, r3, r0          @ ХåեλĤ
        beq     4b                  @ Υǥ쥯ȥꥨȥ
        add     v1, v1, r0          @ dir_ent
        b       5b

    6:  bl      CheckError
    7:  mov     r0, v2              @ fd
        bl      fclose
        ldmfd   sp!, {v1, v2, v6}
        ldmfd   sp!, {pc}

@ ϤʤΤǤǤ
size_dir_ent2:  .long size_dir_ent0
dir_ent2:       .long   dir_ent0        @ 256 bytes
file_stat2:     .long   file_stat0      @ 64 bytes
DirName2:       .long   DirName0

@------------------------------------
@ |m ǻϤޤȤ߹ߥޥ
@------------------------------------
def_func_m:
         stmfd   sp!, {lr}
         bl      GetChar            @
         cmp     v1, #'d'
         beq     func_md            @ mkdir
         cmp     v1, #'o'
         beq     func_mo            @ mo
         cmp     v1, #'v'
         beq     func_mv            @ mv
         b       pop2_and_Error

func_md:
        adr     r0, msg_f_md        @ |md dir [777]
        bl      FuncBegin
        ldr     r0, [r1, #4]        @ permission
        ldr     r1, [r1]            @ directory name
        tst     r0, r0
        ldreq   r0, c755
        beq     2f
        bl      Oct2Bin
        mov     r1, r0
        swi     #sys_mkdir          @ ƥॳ
        bl      CheckError
        ldmfd   sp!, {pc}

c755:   .long   0755

func_mo:
        adr     r0, msg_f_mo        @ |mo dev_name dir fstype
        bl      FuncBegin
        mov     v2, r1              @ exarg
        ldr     r0, [v2]            @ dev_name
        ldr     r1, [v2, #+4]       @ dir_name
        ldr     r2, [v2, #+8]       @ fstype
        ldr     r3, [v2, #+12]      @ flags
        tst     r3, r3              @ Check ReadOnly
        beq     1f                  @ Read/Write
        ldr     r3, [r3]
        mov     r3, #MS_RDONLY      @ ReadOnly FileSystem
    1:
        mov     r4, #0              @ void * data
        swi     #sys_mount          @ ƥॳ
        bl      CheckError
        ldmfd   sp!, {pc}
func_mv:
        adr     r0, msg_f_mv        @ |mv fileold filenew
        bl      FuncBegin
        ldr     r0, [r1]
        ldr     r1, [r1, #4]
        swi     #sys_rename         @ ƥॳ
        bl      CheckError
        ldmfd   sp!, {pc}

@------------------------------------
@ |p ǻϤޤȤ߹ߥޥ
@------------------------------------
def_func_p:
        stmfd   sp!, {lr}
        bl      GetChar             @
        cmp     v1, #'v'
        beq     func_pv             @ pivot_root
        b       pop2_and_Error

func_pv:
        adr     r0, msg_f_pv        @ |pv /dev/hda2 /mnt
        bl      FuncBegin
        ldr     r0, [r1]
        ldr     r1, [r1, #4]
        swi     #sys_pivot_root     @ ƥॳ
        bl      CheckError
        ldmfd   sp!, {pc}

@------------------------------------
@ |r ǻϤޤȤ߹ߥޥ
@------------------------------------
def_func_r:
        stmfd   sp!, {lr}
        bl      GetChar             @
        cmp     v1, #'d'
        beq     func_rd             @ rmdir
        cmp     v1, #'m'
        beq     func_rm             @ rm
        b       pop2_and_Error

func_rd:
        adr     r0, msg_f_rd        @ |rd path
        bl      FuncBegin           @ char ** argp
        ldr     r0, [r1]
        swi     #sys_rmdir          @ ƥॳ
        bl      CheckError
        ldmfd   sp!, {pc}

func_rm:
        adr     r0, msg_f_rm        @ |rm path
        bl      FuncBegin           @ char ** argp
        ldr     r0, [r1]
        swi     #sys_unlink         @ ƥॳ
        bl      CheckError
        ldmfd   sp!, {pc}

@------------------------------------
@ |s ǻϤޤȤ߹ߥޥ
@------------------------------------
def_func_s:
        stmfd   sp!, {lr}
        bl      GetChar             @
        cmp     v1, #'f'
        beq     func_sf             @ swapoff
        cmp     v1, #'o'
        beq     func_so             @ swapon
        cmp     v1, #'y'
        beq     func_sy             @ sync
        b       pop2_and_Error

func_sf:
        adr     r0, msg_f_sf        @ |sf dev_name
        bl      FuncBegin           @ const char * specialfile
        ldr     r0, [r1]
        swi     #sys_swapoff        @ ƥॳ
        bl      CheckError
        ldmfd   sp!, {pc}

func_so:
        adr     r0, msg_f_so        @ |so dev_name
        bl      FuncBegin
        ldr     r0, [r1]            @ const char * specialfile
        mov     r1, #0              @ int swap_flags
        swi     #sys_swapon         @ ƥॳ
        bl      CheckError
        ldmfd   sp!, {pc}

func_sy:
        adr     r0, msg_f_sy        @ |sy
        swi     #sys_sync           @ ƥॳ
        bl      CheckError
        ldmfd   sp!, {pc}

@------------------------------------
@ |u ǻϤޤȤ߹ߥޥ
@------------------------------------
def_func_u:
        stmfd   sp!, {lr}
        bl      GetChar             @
        cmp     v1, #'m'
        beq     func_um             @ umount
        cmp     v1, #'d'
        beq     func_ud             @ URL Decode
        b       pop2_and_Error

func_um:
        adr     r0, msg_f_um        @ |um dev_name
        bl      FuncBegin           @
        ldr     r0, [r1]            @ dev_name
        swi     #sys_umount         @ sys_oldumount ƥॳ
        bl      CheckError
        ldmfd   sp!, {pc}

func_ud:
        mov     r0, #'u'
        ldr     ip, [fp, r0,LSL #2] @  u[0] - u[3]
        ldr     r0, [ip]            @ r0 URL󥳡ʸƬ
        ldr     r1, [ip, #4]        @ r1 ѹϰϤʸ
        ldr     r2, [ip, #8]        @ r2 ˥ǥɸʸƬ
        bl      URL_Decode
        str     r0, [ip, #12]       @ ǥɸʸ
        ldmfd   sp!, {pc}

@------------------------------------
@ |v ǻϤޤȤ߹ߥޥ
@------------------------------------
def_func_v:
        stmfd   sp!, {lr}
        bl      GetChar             @
        cmp     v1, #'e'
        beq     func_ve             @ version
        b       pop2_and_Error

func_ve:
        ldr     r3, version
        mov     r0, #'%'
        str     r3, [fp, r0,LSL #2] @ ɤ߹ߥ
        ldmfd   sp!, {pc}

version:
        .long   VERSION

@------------------------------------
@ |zz ƥॳ
@------------------------------------
def_func_z:
        stmfd   sp!, {lr}
        bl      GetChar             @
        cmp     v1, #'z'
        beq     func_zz             @ system bl
        b       pop2_and_Error

func_zz:
        bl      GetChar             @ skip space
        bl      SystemCall
        bl      CheckError
        ldmfd   sp!, {pc}

@-------------------------------------------------------------------------
@ Ȥ߹ߴؿѥå
@-------------------------------------------------------------------------
    msg_f_ls:   .asciz  "List Directory\n"
                .align  2
    msg_f_md:   .asciz  "Make Directory\n"
                .align  2
    msg_f_mv:   .asciz  "Change Name\n"
                .align  2
    msg_f_mo:   .asciz  "Mount\n"
                .align  2
    msg_f_pv:   .asciz  "Pivot Root\n"
                .align  2
    msg_f_rd:   .asciz  "Remove Directory\n"
                .align  2
    msg_f_rm:   .asciz  "Remove File\n"
                .align  2
    msg_f_sf:   .asciz  "Swap Off\n"
                .align  2
    msg_f_so:   .asciz  "Swap On\n"
                .align  2
    msg_f_sy:   .asciz  "Sync\n"
                .align  2
    msg_f_um:   .asciz  "Unmount\n"
                .align  2

@---------------------------------------------------------------------
@ v6 ʸ16ʿɤΥå
@ ʤѴ v6 ֤. ʤ饭꡼å
@---------------------------------------------------------------------

IsNum2: cmp     v6, #'0'            @ 0 - 9
        bcs     1f
        msr     cpsr_f, #0x20000000 @ set carry v6<'0'
        mov     pc, lr              @ return
    1:  cmp     v6, #':'            @ set carry v6>'9'
        subcc   v6, v6, #'0         @ Ѵ Cy=0
        mov     pc, lr              @ return

IsHex:
        stmfd   sp!, {lr}
        bl      IsHex1              @ ʸ?
        bcc     1f
        bl      IsHex2              @ Ѿʸ?
    1:  addcc   v6, v6, #10
        ldmfd   sp!, {pc}

IsHex1:
        cmp     v6, #'A             @ ʸ(A-Z)?
        bcs     1f
        msr     cpsr_f, #0x20000000 @ if v6<'A' Cy=1
        mov     pc, lr              @ return
    1:  cmp     v6, #'F+1           @ if v6>'F' Cy=1
        subcc   v6, v6, #'A         @ yes
        mov     pc, lr              @ return

IsHex2:
        cmp     v6, #'a             @ Ѿʸ(a-z)?
        bcs     1f
        msr     cpsr_f, #0x20000000 @ if v6<'a' Cy=1
        mov     pc, lr              @ return
    1:  cmp     v6, #'f+1           @ if v6>'f' Cy=1
        subcc   v6, v6, #'a         @ yes
        mov     pc, lr              @ return

IsHexNum:
        stmfd   sp!, {lr}
        bl      IsHex               @ ʸ?
        bcc     1f                  @ yes
        bl      IsNum2              @ ?
    1:  ldmfd   sp!, {pc}

@-------------------------------------------------------------------------
@ URLǥ
@
@ r0 URL󥳡ʸƬ
@ r1 ѹϰϤʸ
@ r2 ˥ǥɸʸƬ
@ r0 ˥ǥɸʸ֤
@-------------------------------------------------------------------------
URL_Decode:
        stmfd   sp!, {v4-v8, lr}
        add     v7, r0, r1
        sub     v7, v7, #1
        mov     v4, #0
    1:
        ldrb    v5, [r0], #1
        cmp     v5, #'+
        bne     2f
        mov     v5, #' '
        strb    v5, [r2, v4]
        b       4f
    2:  cmp     v5, #'%
        beq     3f
        strb    v5, [r2, v4]
        b       4f
    3:
        mov     v5, #0
        ldrb    v6, [r0], #1
        bl      IsHexNum
        bcs     4f
        add     v5, v5, v6
        ldrb    v6, [r0], #1
        bl      IsHexNum
        bcs     4f
        mov     v5, v5, LSL #4
        add     v5, v5, v6
        strb    v5, [r2, v4]
    4:
        add     v4, v4, #1
        cmp     r0, v7
        ble     1b

        mov     v5, #0
        strb    v5, [r2, v4]
        mov     r0, v4              @ ʸ֤
        ldmfd   sp!, {v4-v8, pc}

@-------------------------------------------------------------------------
@ Ȥ߹ߴؿ
@-------------------------------------------------------------------------
FuncBegin:
        stmfd   sp!, {lr}
        bl      OutAsciiZ
        bl      GetChar             @ get *
        cmp     v1, #'*
        bne     1f
        bl      SkipEqualExp        @ r0 ˥ɥ쥹
        mov     r2, v4              @ v4
        mov     v4, r0              @ RangeCheckv4򸫤
        bl      RangeCheck          @ ԡϰϥå
        mov     v4, r2              @ ԡ
        bcs     4f                  @ ϰϳ򥢥
        bl      GetString2          @ FileName˥ԡ
        b       3f
    1:  ldrb    ip, [v3]
        cmp     ip, #'"'
        bleq    GetChar             @ skip "
    2:  bl      GetString           @ ѥ̾μ
    3:  bl      ParseArg            @ Υѡ
        ldr     r1, exarg2
        ldmfd   sp!, {pc}
    4:  mov     v1, #0xFF           @ 顼ʸ FF
        b       LongJump            @ ǽϰϤĶ

@-------------------------------------------------------------------------
@ 8ʿʸͤѴ
@ r0 8ʿʸͤѴ r1 ֤
@-------------------------------------------------------------------------
Oct2Bin:
        stmfd   sp!, {r1, r2, lr}
        bl      GetOctal            @ r1
        bhi     2f                  @ exit
        mov     r2, r1
    1:
        bl      GetOctal
        bhi     2f
        add     r2, r2, r1, LSL#3
        b       1b
    2:
        mov     r1, r2
        ldmfd   sp!, {r1, r2, pc}

@-------------------------------------------------------------------------
@ r2 μ8ʿʸͤѴ r1 ֤
@ 8ʿʸǤʤɤ bhiȽǽ
@-------------------------------------------------------------------------
GetOctal:
        ldr     r1, [r0], #1
        sub     r1, r1, #'0
        cmp     r1, #7
        mov     pc, lr

@-------------------------------------------------------------------------
@ եɽ
@ r0 ˥ե̾
@-------------------------------------------------------------------------
DispFile:
        stmfd   sp!, {lr}
        bl      fropen              @ open
        bl      CheckError
        bmi     3f
        mov     r3, r0              @ FileDesc
        mov     r2, #4              @ read 1 byte
        stmfd   sp!, {r0}
        mov     r1, sp              @ r1  address
    1:
        mov     r0, r3              @ r0  fd
        swi     #sys_read
        tst     r0, r0
        beq     2f
        mov     r2, r0              @ r2  length
        mov     r0, #1              @ r0  stdout
        swi     #sys_write
        b       1b
    2:
        ldmfd   sp!, {r0}
        bl      fclose
    3:  ldmfd   sp!, {pc}

.endif

@==============================================================
.bss

                .align   2
cgiflag0:       .long   0
save_stack0:    .long   0
current_arg0:   .long   0
argc0:          .long   0
argvp0:         .long   0
envp0:          .long   0
argc_vtl0:      .long   0
argp_vtl0:      .long   0
exarg0:         .skip   (ARGMAX+1)*4    @ execve 
ipipe0:         .long   0
opipe0:         .long   0
ipipe20:        .long   0
opipe20:        .long   0
stat_addr0:     .long   0

                .align  2
input20:        .skip   MAXLINE
FileName0:      .skip   FNAMEMAX
pid0:           .long   0               @ fp-24
FOR_direct0:    .byte   0               @ fp-20
ExpError0:      .byte   0               @ fp-19
ZeroDiv0:       .byte   0               @ fp-18
SigInt0:        .byte   0               @ fp-17
VSTACK0:        .long   0               @ fp-16
FileDescW0:     .long   0               @ fp-12
FileDesc0:      .long   0               @ fp-8
ReadFrom0:      .byte   0               @ fp-4
ExecMode0:      .byte   0               @ fp-3
EOL0:           .byte   0               @ fp-2
LSTACK0:        .byte   0               @ fp-1
VarArea0:       .skip   256*4           @ fp    Ⱦ128dwordLSTACK
VarStack0:      .skip   VSTACKMAX*4     @ fp+1024

.ifdef VTL_LABEL
                .align  2
LabelTable0:    .skip   LABELMAX*16     @ 1024*16 bytes
TablePointer0:  .long   0
.endif
                .align  2
CodeArea0:      .skip   MEMINIT         @ Code & Data & Heap

